/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 24 "vhd2vl.y" /* yacc.c:339  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <assert.h>
#include "def.h"

int yylex(void);
void yyerror(const char *s);

int vlog_ver=0;  /* default is -g1995 */

/* You will of course want to tinker with this if you use a debugging
 * malloc(), otherwise all the line numbers will point here.
 */
void *xmalloc(size_t size) {
	void *p = malloc(size);
	if (!p) {
		perror("malloc");
		exit(2);
	}
	return p;
}

int skipRem = 0;
int lineno=1;

sglist *io_list=NULL;
sglist *sig_list=NULL;
sglist *type_list=NULL;
blknamelist *blkname_list=NULL;

/* need a stack of clock-edges because all edges are processed before all processes are processed.
 * Edges are processed in source file order, processes are processed in reverse source file order.
 * The original scheme of just one clkedge variable makes all clocked processes have the edge sensitivity
 * of the last clocked process in the file.
 */
int clkedges[MAXEDGES];
int clkptr = 0;
int delay=1;
int dolist=1;
int np=1;
char wire[]="wire";
char reg[]="reg";
int dowith=0;
slist *slwith;

/* Indentation variables */
int indent=0;
slist *indents[MAXINDENT];

struct vrange *new_vrange(enum vrangeType t)
{
  struct vrange *v=xmalloc(sizeof(vrange));
  v->vtype=t;
  v->nlo = NULL;
  v->nhi = NULL;
  v->size_expr = NULL;
  v->sizeval = 0;
  v->xlo = NULL;
  v->xhi = NULL;
  return v;
}

void fslprint(FILE *fp,slist *sl){
  if(sl){
    assert(sl != sl->slst);
    fslprint(fp,sl->slst);
    switch(sl->type){
    case 0 :
      assert(sl != sl->data.sl);
      fslprint(fp,sl->data.sl);
      break;
    case 1 : case 4 :
      fprintf(fp,"%s",sl->data.txt);
      break;
    case 2 :
      fprintf(fp,"%d",sl->data.val);
      break;
    case 3 :
      fprintf(fp,"%s",*(sl->data.ptxt));
      break;
    }
  }
}

void slprint(slist *sl){
  fslprint(stdout, sl);
}

slist *copysl(slist *sl){
  if(sl){
    slist *newsl;
    newsl = xmalloc(sizeof(slist));
    *newsl = *sl;
    if (sl->slst != NULL) {
      assert(sl != sl->slst);
      newsl->slst = copysl(sl->slst);
    }
    switch(sl->type){
    case 0 :
      if (sl->data.sl != NULL) {
        assert(sl != sl->data.sl);
        newsl->data.sl = copysl(sl->data.sl);
      }
      break;
    case 1 : case 4 :
      newsl->data.txt = xmalloc(strlen(sl->data.txt) + 1);
      strcpy(newsl->data.txt, sl->data.txt);
      break;
    }
    return newsl;
  }
  return NULL;
}

slist *addtxt(slist *sl, const char *s){
  slist *p;

  if(s == NULL)
    return sl;
  p = xmalloc(sizeof *p);
  p->type = 1;
  p->slst = sl;
  p->data.txt = xmalloc(strlen(s) + 1);
  strcpy(p->data.txt, s);

  return p;
}

slist *addothers(slist *sl, char *s){
  slist *p;

  if(s == NULL)
    return sl;
  p = xmalloc(sizeof *p);
  p->type = 4;
  p->slst = sl;
  p->data.txt = xmalloc(strlen(s) + 1);
  strcpy(p->data.txt, s);

  return p;
}

slist *addptxt(slist *sl, char **s){
  slist *p;

  if(s == NULL)
    return sl;

  p = xmalloc(sizeof *p);
  p->type = 3;
  p->slst = sl;
  p->data.ptxt = s;

  return p;
}

slist *addval(slist *sl, int val){
  slist *p;

  p = xmalloc(sizeof(slist));
  p->type = 2;
  p->slst = sl;
  p->data.val = val;

  return p;
}

slist *addsl(slist *sl, slist *sl2){
  slist *p;
  if(sl2 == NULL) return sl;
  p = xmalloc(sizeof(slist));
  p->type = 0;
  p->slst = sl;
  p->data.sl = sl2;
  return p;
}

slist *addvec(slist *sl, char *s){
  sl=addval(sl,strlen(s));
  sl=addtxt(sl,"'b ");
  sl=addtxt(sl,s);
  return sl;
}

slist *addvec_base(slist *sl, char *b, char *s){
  const char *base_str="'b ";
  int base_mult=1;
  if (strcasecmp(b,"X") == 0) {
     base_str="'h "; base_mult=4;
  } else if (strcasecmp(b,"O") == 0) {
     base_str="'o "; base_mult=3;
  } else {
     fprintf(stderr,"Warning on line %d: NAME STRING rule matched but "
       "NAME='%s' is not X or O.\n",lineno, b);
  }
  sl=addval(sl,strlen(s)*base_mult);
  sl=addtxt(sl,base_str);
  sl=addtxt(sl,s);
  return sl;
}

slist *addind(slist *sl){
  if(sl)
    sl=addsl(indents[indent],sl);
  return sl;
}

slist *addpar(slist *sl, vrange *v){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl," [");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"] ");
  } else {
    sl=addtxt(sl," ");
  }
  return sl;
}

slist *addpar_snug(slist *sl, vrange *v){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

/* This function handles array of vectors in signal lists */
slist *addpar_snug2(slist *sl, vrange *v, vrange *v1){
  if(v->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v->nhi != NULL){
      sl=addsl(sl,v->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->nlo);
    sl=addtxt(sl,"]");
  }
  if(v1->nlo != NULL) {   /* indexes are simple expressions */
    sl=addtxt(sl,"[");
    if(v1->nhi != NULL){
      sl=addsl(sl,v1->nhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v1->nlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

slist *addpost(slist *sl, vrange *v){
  if(v->xlo != NULL) {
    sl=addtxt(sl,"[");
    if(v->xhi != NULL){
      sl=addsl(sl,v->xhi);
      sl=addtxt(sl,":");
    }
    sl=addsl(sl,v->xlo);
    sl=addtxt(sl,"]");
  }
  return sl;
}

slist *addwrap(const char *l,slist *sl,const char *r){
slist *s;
  s=addtxt(NULL,l);
  s=addsl(s,sl);
  return addtxt(s,r);
}

expdata *addnest(struct expdata *inner)
{
  expdata *e;
  e=xmalloc(sizeof(expdata));
  if (inner->op == 'c') {
    e->sl=addwrap("{",inner->sl,"}");
  } else {
    e->sl=addwrap("(",inner->sl,")");
  }
  return e;
}

slist *addrem(slist *sl, slist *rem)
{
  if (rem) {
    sl=addtxt(sl, "  ");
    sl=addsl(sl, rem);
  } else {
    sl=addtxt(sl, "\n");
  }
  return sl;
}

sglist *lookup(sglist *sg,char *s){
  for(;;){
    if(sg == NULL || strcmp(sg->name,s)==0)
      return sg;
    sg=sg->next;
  }
}

char *sbottom(slist *sl){
  while(sl->slst != NULL)
    sl=sl->slst;
  return sl->data.txt;
}

const char *inout_string(int type)
{
  const char *name=NULL;
  switch(type) {
    case 0: name="input"  ; break;
    case 1: name="output" ; break;
    case 2: name="inout"  ; break;
    default: break;
  }
  return name;
}

int prec(int op){
  switch(op){
  case 'o': /* others */
    return 9;
    break;
  case 't':case 'n':
    return 8;
    break;
  case '~':
    return 7;
    break;
  case 'p': case 'm':
    return 6;
    break;
  case '*': case '/': case '%':
    return 5;
    break;
  case '+': case '-':
    return 4;
    break;
  case '&':
    return 3;
    break;
  case '^':
    return 2;
    break;
  case '|':
    return 1;
    break;
   default:
    return 0;
    break;
  }
}

expdata *addexpr(expdata *expr1,int op,const char* opstr,expdata *expr2){
slist *sl1,*sl2;
  if(expr1 == NULL)
    sl1=NULL;
  else if(expr1->op == 'c')
    sl1=addwrap("{",expr1->sl,"}");
  else if(prec(expr1->op) < prec(op))
    sl1=addwrap("(",expr1->sl,")");
  else
    sl1=expr1->sl;

  if(expr2->op == 'c')
    sl2=addwrap("{",expr2->sl,"}");
  else if(prec(expr2->op) < prec(op))
    sl2=addwrap("(",expr2->sl,")");
  else
    sl2=expr2->sl;

  if(expr1 == NULL)
    expr1=expr2;
  else
    free(expr2);

  expr1->op=op;
  sl1=addtxt(sl1,opstr);
  sl1=addsl(sl1,sl2);
  expr1->sl=sl1;
  return expr1;
}

void slTxtReplace(slist *sl, const char *match, const char *replace){
  if(sl){
    slTxtReplace(sl->slst, match, replace);
    switch(sl->type) {
    case 0 :
      slTxtReplace(sl->data.sl, match, replace);
      break;
    case 1 :
      if (strcmp(sl->data.txt, match) == 0) {
        sl->data.txt = strdup(replace);
      }
      break;
    case 3 :
      if (strcmp(*(sl->data.ptxt), match) == 0) {
        *(sl->data.ptxt) = strdup(replace);
      }
      break;
    }
  }
}


/* XXX todo: runtime engage clkedge debug */
void push_clkedge(int val, const char *comment)
{
  if (0) fprintf(stderr,"clock event push: line=%d clkptr=%d, value=%d (%s)\n",lineno,clkptr,val,comment);
  clkedges[clkptr++]=val;
  assert(clkptr < MAXEDGES);
}

int pull_clkedge(slist *sensitivities)
{
  int clkedge;
  assert(clkptr>0);
  clkedge = clkedges[--clkptr];
  if (0) {
     fprintf(stderr,"clock event pull: value=%d, sensistivity list = ", clkedge);
     fslprint(stderr,sensitivities);
     fprintf(stderr,"\n");
  }
  return clkedge;
}

/* XXX maybe it's a bug that some uses don't munge clocks? */
slist *add_always(slist *sl, slist *sensitivities, slist *decls, int munge)
{
           int clkedge;
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"always @(");
           if (munge) {
             clkedge = pull_clkedge(sensitivities);
             if(clkedge) {
               sl=addtxt(sl,"posedge ");
               /* traverse $4->sl replacing " or " with " or posedge " if there is a clockedge */
               slTxtReplace(sensitivities," or ", " or posedge ");
             } else {
               sl=addtxt(sl,"negedge ");
               slTxtReplace(sensitivities," or ", " or negedge ");
             }
           }
           sl=addsl(sl,sensitivities);
           sl=addtxt(sl,") begin");
           if(decls){
             sl=addtxt(sl," : P");
             sl=addval(sl,np++);
             sl=addtxt(sl,"\n");
             sl=addsl(sl,decls);
           }
           sl=addtxt(sl,"\n");
           return sl;
}

void fixothers(slist *size_expr, slist *sl) {
  if(sl) {
    fixothers(size_expr, sl->slst);
    switch(sl->type) {
    case 0 :
      fixothers(size_expr,sl->data.sl);
      break;
    case 4 : {
      /* found an (OTHERS => 'x') clause - change to type 0, and insert the
       * size_expr for the corresponding signal */
      slist *p;
      slist *size_copy = xmalloc(sizeof(slist));
      size_copy = copysl(size_expr);
      if (0) {
        fprintf(stderr,"fixothers type 4 size_expr ");
        fslprint(stderr,size_expr);
        fprintf(stderr,"\n");
      }
      p = addtxt(NULL, "1'b");
      p = addtxt(p, sl->data.txt);
      p = addwrap("{",p,"}");
      p = addsl(size_copy, p);
      p = addwrap("{",p,"}");
      sl->type=0;
      sl->slst=p;
      sl->data.sl=NULL;
      break;
    } /* case 4 */
    } /* switch */
  }
}

void findothers(slval *sgin,slist *sl){
  sglist *sg = NULL;
  int size = -1;
  int useExpr=0;
  if (0) {
    fprintf(stderr,"findothers lhs ");
    fslprint(stderr,sgin->sl);
    fprintf(stderr,", sgin->val %d\n", sgin->val);
  }
  if(sgin->val>0) {
    size=sgin->val;
  } else if (sgin->range != NULL) {
    if (sgin->range->vtype != tVRANGE) {
      size=1;
    } else if (sgin->range->sizeval > 0) {
      size=sgin->range->sizeval;
    } else if (sgin->range->size_expr != NULL) {
      useExpr = 1;
      fixothers(sgin->range->size_expr, sl);
    }
  } else {
    if((sg=lookup(io_list,sgin->sl->data.txt))==NULL) {
      sg=lookup(sig_list,sgin->sl->data.txt);
    }
    if(sg) {
      if(sg->range->vtype != tVRANGE) {
        size=1;
      } else {
        if (sg->range->sizeval > 0) {
          size = sg->range->sizeval;
        } else {
          assert (sg->range->size_expr != NULL);
          useExpr = 1;
          fixothers(sg->range->size_expr, sl);
        }
      }
    } else {
      /* lookup failed, there was no vrange or size value in sgin - so just punt, and assign size=1 */
      size=1;
    }  /* if(sg) */
  }
  if (!useExpr) {
    slist *p;
    assert(size>0);
    /* use size */
    p = addval(NULL,size);
    fixothers(p,sl);
  }
}

/* code to find bit number of the msb of n */
int find_msb(int n)
{
    int k=0;
    if(n&0xff00){
        k|=8;
        n&=0xff00;
    }
    if(n&0xf0f0){
        k|=4;
        n&=0xf0f0;
    }
    if(n&0xcccc){
        k|=2;
        n&=0xcccc;
    }
    if(n&0xaaaa){
        k|=1;
        n&=0xaaaa;
    }
    return k;
}

static char time_unit[2]="\0\0", new_unit[2]="\0\0";
static void set_timescale(const char *s)
{
    if (0) fprintf(stderr,"set_timescale (%s)\n", s);
    new_unit[0] = time_unit[0];
         if (strcasecmp(s,"ms") == 0) { new_unit[0] = 'm'; }
    else if (strcasecmp(s,"us") == 0) { new_unit[0] = 'u'; }
    else if (strcasecmp(s,"ns") == 0) { new_unit[0] = 'n'; }
    else if (strcasecmp(s,"ps") == 0) { new_unit[0] = 'p'; }
    else {
        fprintf(stderr,"Warning on line %d: AFTER NATURAL NAME pattern"
               " matched, but NAME='%s' should be a time unit.\n",lineno,s);
    }
    if (new_unit[0] != time_unit[0]) {
        if (time_unit[0] != 0) {
            fprintf(stderr,"Warning on line %d: inconsistent time unit (%s) ignored\n", lineno, s);
        } else {
            time_unit[0] = new_unit[0];
        }
    }
}

slist *output_timescale(slist *sl)
{
    if (time_unit[0] != 0) {
        sl = addtxt(sl, "`timescale 1 ");
        sl = addtxt(sl, time_unit);
        sl = addtxt(sl, "s / 1 ");
        sl = addtxt(sl, time_unit);
        sl = addtxt(sl, "s\n");
    } else {
        sl = addtxt(sl, "// no timescale needed\n");
    }
    return sl;
}

slist *setup_port(sglist *s_list, int dir, vrange *type) {
  slist *sl;
  sglist *p;
  if (vlog_ver == 1) {
    sl=addtxt(NULL,NULL);
  }
  else {
    sl=addtxt(NULL,inout_string(dir));
    sl=addpar(sl,type);
  }
  p=s_list;
  for(;;){
    p->type=wire;
    if (vlog_ver == 1) p->dir=inout_string(dir);
    p->range=type;
    if (vlog_ver == 0) sl=addtxt(sl, p->name);
    if(p->next==NULL)
      break;
    p=p->next;
    if (vlog_ver == 0) sl=addtxt(sl,", ");
  }
  if (vlog_ver == 0) sl=addtxt(sl,";\n");
  p->next=io_list;
  io_list=s_list;
  return sl;
}

slist *emit_io_list(slist *sl)
{
              sglist *p;
              sl=addtxt(sl,"(\n");
              p=io_list;
              for(;;){
                if (vlog_ver == 1) {
                  sl=addtxt(sl,p->dir);
                  sl=addtxt(sl," ");
                  sl=addptxt(sl,&(p->type));
                  sl=addpar(sl,p->range);
                }
                sl=addtxt(sl,p->name);
                p=p->next;
                if(p)
                  sl=addtxt(sl,",\n");
                else{
                  sl=addtxt(sl,"\n");
                  break;
                }
              }
              sl=addtxt(sl,");\n\n");
              return sl;
}

#line 727 "vhd2vl.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "vhd2vl.tab.h".  */
#ifndef YY_YY_VHD2VL_TAB_H_INCLUDED
# define YY_YY_VHD2VL_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    REM = 258,
    ENTITY = 259,
    IS = 260,
    PORT = 261,
    GENERIC = 262,
    IN = 263,
    OUT = 264,
    INOUT = 265,
    MAP = 266,
    INTEGER = 267,
    BIT = 268,
    BITVECT = 269,
    DOWNTO = 270,
    TO = 271,
    TYPE = 272,
    END = 273,
    ARCHITECTURE = 274,
    COMPONENT = 275,
    OF = 276,
    ARRAY = 277,
    SIGNAL = 278,
    BEGN = 279,
    NOT = 280,
    WHEN = 281,
    WITH = 282,
    EXIT = 283,
    SELECT = 284,
    OTHERS = 285,
    PROCESS = 286,
    VARIABLE = 287,
    CONSTANT = 288,
    IF = 289,
    THEN = 290,
    ELSIF = 291,
    ELSE = 292,
    CASE = 293,
    FOR = 294,
    LOOP = 295,
    GENERATE = 296,
    AFTER = 297,
    AND = 298,
    OR = 299,
    XOR = 300,
    MOD = 301,
    LASTVALUE = 302,
    EVENT = 303,
    POSEDGE = 304,
    NEGEDGE = 305,
    STRING = 306,
    NAME = 307,
    RANGE = 308,
    NULLV = 309,
    OPEN = 310,
    CONVFUNC_1 = 311,
    CONVFUNC_2 = 312,
    BASED = 313,
    FLOAT = 314,
    LEFT = 315,
    NATURAL = 316,
    ORL = 317,
    ANDL = 318,
    XNOR = 319,
    BIGEQ = 320,
    LESSEQ = 321,
    NOTEQ = 322,
    EQUAL = 323,
    UMINUS = 324,
    UPLUS = 325,
    NOTL = 326
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 685 "vhd2vl.y" /* yacc.c:355  */

  char * txt; /* String */
  int n;      /* Value */
  vrange *v;  /* Signal range */
  sglist *sg; /* Signal list */
  slist *sl;  /* String list */
  expdata *e; /* Expression structure */
  slval *ss;  /* Signal structure */

#line 849 "vhd2vl.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_VHD2VL_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 866 "vhd2vl.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1143

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  87
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  55
/* YYNRULES -- Number of rules.  */
#define YYNRULES  181
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  650

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   326

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    74,    84,
      80,    81,    75,    72,    85,    73,     2,    76,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    83,    82,
      66,    62,    67,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    86,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    63,    64,    65,
      68,    69,    70,    71,    77,    78,    79
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   757,   757,   772,   780,   791,   792,   795,   796,   802,
     802,   804,   804,   806,   806,   808,   808,   810,   812,   815,
     816,   820,   847,   878,   899,   921,   941,   962,   975,   988,
    1002,  1017,  1018,  1019,  1022,  1025,  1031,  1036,  1037,  1051,
    1089,  1093,  1108,  1109,  1113,  1123,  1126,  1129,  1130,  1153,
    1178,  1187,  1227,  1240,  1248,  1249,  1257,  1258,  1261,  1274,
    1289,  1291,  1303,  1316,  1344,  1357,  1377,  1386,  1401,  1428,
    1457,  1482,  1521,  1560,  1561,  1564,  1565,  1567,  1568,  1580,
    1581,  1584,  1587,  1590,  1595,  1597,  1598,  1606,  1625,  1646,
    1647,  1667,  1691,  1693,  1707,  1726,  1739,  1761,  1783,  1798,
    1804,  1814,  1815,  1825,  1834,  1843,  1850,  1853,  1854,  1861,
    1862,  1863,  1866,  1867,  1875,  1891,  1895,  1908,  1911,  1912,
    1918,  1922,  1931,  1932,  1942,  1943,  1944,  1945,  1946,  1947,
    1956,  1960,  1967,  1972,  1982,  1996,  2020,  2042,  2050,  2057,
    2063,  2069,  2094,  2100,  2107,  2116,  2117,  2118,  2119,  2120,
    2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2139,  2143,
    2146,  2152,  2153,  2156,  2161,  2166,  2174,  2191,  2208,  2225,
    2242,  2259,  2278,  2286,  2293,  2301,  2317,  2320,  2323,  2326,
    2329,  2336
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "REM", "ENTITY", "IS", "PORT", "GENERIC",
  "IN", "OUT", "INOUT", "MAP", "INTEGER", "BIT", "BITVECT", "DOWNTO", "TO",
  "TYPE", "END", "ARCHITECTURE", "COMPONENT", "OF", "ARRAY", "SIGNAL",
  "BEGN", "NOT", "WHEN", "WITH", "EXIT", "SELECT", "OTHERS", "PROCESS",
  "VARIABLE", "CONSTANT", "IF", "THEN", "ELSIF", "ELSE", "CASE", "FOR",
  "LOOP", "GENERATE", "AFTER", "AND", "OR", "XOR", "MOD", "LASTVALUE",
  "EVENT", "POSEDGE", "NEGEDGE", "STRING", "NAME", "RANGE", "NULLV",
  "OPEN", "CONVFUNC_1", "CONVFUNC_2", "BASED", "FLOAT", "LEFT", "NATURAL",
  "'='", "ORL", "ANDL", "XNOR", "'<'", "'>'", "BIGEQ", "LESSEQ", "NOTEQ",
  "EQUAL", "'+'", "'-'", "'&'", "'*'", "'/'", "UMINUS", "UPLUS", "NOTL",
  "'('", "')'", "';'", "':'", "'\\''", "','", "'|'", "$accept", "trad",
  "rem", "remlist", "opt_is", "opt_entity", "opt_architecture",
  "opt_begin", "generate", "endgenerate", "norem", "yesrem", "entity",
  "genlist", "portlist", "dir", "type", "vec_range", "updown",
  "architecture", "doindent", "unindent", "a_decl", "opt_generic",
  "nolist", "yeslist", "s_list", "a_body", "oname", "optname",
  "gen_optname", "edge", "yeswith", "with_list", "with_item", "p_decl",
  "p_body", "elsepart", "cases", "wlist", "wvalue", "sign_list",
  "sigvalue", "nodelay", "delay", "map_list", "map_item", "mvalue",
  "generic_map_list", "generic_map_item", "signal", "expr", "exprc",
  "conf", "simple_expr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,    61,   317,   318,   319,    60,    62,   320,   321,
     322,   323,    43,    45,    38,    42,    47,   324,   325,   326,
      40,    41,    59,    58,    39,    44,   124
};
# endif

#define YYPACT_NINF -424

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-424)))

#define YYTABLE_NINF -77

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      68,    68,    33,    51,  -424,  -424,  -424,    28,    38,    68,
      68,    78,    84,    88,  -424,   113,    66,    68,  -424,   134,
     149,  -424,    80,    86,    68,    68,    68,  -424,   124,   124,
     240,    29,   154,   105,   165,   132,   209,   223,   124,  -424,
     239,    68,  -424,   211,   122,   213,   367,   304,   307,   241,
      68,   248,   124,    68,   267,  -424,   256,  -424,    26,    68,
    -424,  -424,  -424,   122,     8,  -424,    68,   122,    30,   323,
     314,   155,   122,  -424,   355,   737,   238,    68,   311,  -424,
     353,    42,   298,   124,   374,   186,   331,   737,   138,   324,
     380,   313,   768,   331,   312,  -424,   326,   737,  -424,    18,
     329,  -424,   354,   737,   737,   262,  -424,   852,  -424,   163,
     336,  -424,   318,   338,  -424,   164,   124,   737,   419,    68,
     388,  -424,   238,   358,  -424,   436,    68,   400,   389,   417,
     857,   238,    69,   445,  -424,   446,   331,   768,   578,  1062,
     289,  -424,   496,   465,   428,   737,  -424,  -424,   737,  -424,
    -424,  -424,   470,   952,   737,   737,   737,   737,   737,   737,
     737,   737,   737,   737,   737,   202,   318,   194,   415,  -424,
    -424,  -424,   318,   318,   318,   318,   318,  -424,    19,  -424,
     446,   124,   737,   453,   454,   459,  -424,  -424,   737,   478,
      68,   460,    68,    68,  -424,   461,   463,   464,  -424,  -424,
     940,    -9,   737,   643,   695,   712,   524,   768,   768,  -424,
     737,   737,    68,   965,   282,   483,  -424,  1067,   135,   381,
     398,   357,   177,   -32,   -32,   -32,  -424,  -424,  -424,  -424,
     448,   493,  -424,   229,   229,  -424,  -424,   376,    68,  -424,
     473,  -424,   152,   535,    68,    68,   480,   870,    68,  -424,
     484,   309,  -424,  -424,    68,   331,  -424,   440,   737,   440,
     737,   440,   737,  -424,  -424,   295,   295,    68,   157,   893,
     124,  -424,   -15,   514,  -424,   124,  -424,    68,  -424,   122,
    -424,   124,    68,    68,  -424,   331,   238,   555,   568,   737,
    -424,   548,   307,  -424,   440,   440,   440,  -424,   737,   737,
      68,   500,   501,   502,   507,  -424,   124,   505,   508,   124,
    -424,   737,   527,   509,   515,   518,  -424,  1028,   124,   570,
     581,  1022,  1022,  -424,   519,  -424,  -424,  -424,  -424,    68,
     523,   525,  -424,   538,  -424,  -424,  -424,    68,   546,    14,
     528,  -424,   571,   446,  -424,  -424,    68,  -424,    68,   531,
      68,   737,    68,    68,  -424,   579,   768,  -424,   122,    68,
    -424,   540,    68,    68,   605,  -424,    68,   614,    68,   221,
    1028,   442,    68,   786,   552,  -424,    31,   261,   690,   616,
      68,  -424,  -424,   419,   618,   588,  -424,  -424,    68,   615,
    -424,    -2,  -424,  -424,   613,   559,  -424,  -424,   564,     5,
     561,  1067,  -424,  -424,  -424,    68,   585,   567,   386,   331,
     331,   572,   569,   622,  -424,   581,   581,   446,   635,   574,
     737,   107,  -424,   594,   600,    68,   582,   598,    68,   660,
     737,  -424,   737,    68,   589,   590,    64,   335,   636,   121,
     670,   669,    68,   617,   612,   446,   446,   446,   601,   446,
    -424,  -424,   602,  -424,   629,   596,  -424,   506,   621,  -424,
    -424,   737,  -424,   678,  -424,   905,   752,  -424,   638,   639,
     644,   620,    -5,    68,  -424,   810,    68,   737,  -424,  -424,
     631,   624,   628,   632,  -424,   637,  -424,  -424,   352,    52,
    -424,   645,    68,  1067,   642,    68,   768,   646,   649,   654,
    -424,   699,    68,    77,   705,   834,   737,   737,  -424,    68,
      68,  -424,  -424,   651,  -424,  -424,  -424,   127,  -424,  -424,
     768,   700,  -424,   685,   116,   717,   737,   737,   917,  -424,
      68,  -424,  -424,    68,  -424,    68,  -424,   295,   658,   377,
    -424,   674,   -39,   703,  1004,  1016,  -424,    68,  -424,  -424,
     662,    68,   727,   386,   714,   731,   683,   686,   673,  -424,
    -424,    68,  -424,   676,  -424,   728,   725,   170,   386,    68,
     732,  -424,  -424,    68,    68,    68,  -424,  -424,   424,   446,
    -424,  -424,   726,   421,  -424,   688,    68,    68,  -424,  -424,
    -424,    68,   768,  -424,   694,    68,    68,  -424,  -424,    68,
    -424,  -424,   754,   759,  -424,   237,  -424,  -424,  -424,    68,
    -424,  -424,   705,   738,   739,    68,   763,   424,  -424,  -424,
     701,   713,  -424,   765,  -424,   779,    68,    68,   719,   769,
    -424,  -424,   784,   723,   776,   790,   446,   778,   733,   734,
    -424,   795,    68,   783,  -424,   446,   736,  -424,    68,  -424
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       5,     7,     0,     0,     6,     8,     1,     0,     0,     5,
       5,     0,     0,     3,     4,     5,     0,     5,    57,     0,
       0,     2,     0,     0,     5,     5,     5,    47,     0,     0,
       0,     5,     0,     0,     0,     0,     0,     0,     0,    45,
       0,     5,    58,     0,     0,     0,     0,     0,     9,     0,
       5,     0,     0,     5,    36,    34,     0,    38,     5,     5,
      31,    32,    33,     0,     0,    10,     5,     0,    77,     0,
       0,     0,     0,    59,     0,     0,     0,     5,     0,    26,
       0,     5,     0,     0,    54,     0,     0,     0,   134,     0,
      13,     0,     0,     0,     0,    57,     0,     0,   138,   134,
       0,   139,   140,     0,     0,     0,   137,     0,   173,   134,
       0,   174,     0,     0,   172,    40,     0,     0,    11,     5,
       0,    27,     0,     0,    56,     0,     5,     0,   134,     0,
       0,     0,    78,     0,    14,    73,     0,     0,     0,     0,
       0,   161,     0,     0,     0,     0,   152,   142,     0,   141,
     146,   145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   134,     0,    37,
      42,    43,     0,     0,     0,     0,     0,    25,     5,    12,
      73,     0,     0,     0,     0,     0,    56,    48,     0,     0,
       5,     0,     5,     5,    74,     0,     0,   112,   152,   165,
       0,     0,     0,     0,     0,     0,    15,     0,     0,    45,
       0,     0,     5,     0,     0,     0,   160,    35,   153,   154,
     155,   151,   156,   147,   148,   144,   149,   150,    41,   175,
       0,     0,   181,   176,   177,   178,   179,    39,     5,    23,
       0,    28,     5,     0,     5,     5,     0,     0,     5,    84,
     135,     0,    19,    46,     5,     0,   162,   166,     0,   169,
       0,   167,     0,    16,    17,   163,   164,     5,     0,     0,
       0,   157,     0,     0,   180,     0,    21,     5,    29,     0,
      51,     0,     5,     5,    19,     0,     0,     0,     0,     0,
      44,    89,     9,   113,   170,   168,   171,    46,     0,     0,
       5,     0,     0,     0,     0,    24,     0,     0,     0,     0,
      49,     0,     0,     0,     0,     0,    20,   118,     0,     0,
       0,     0,     0,    50,     0,   159,   158,   143,    30,     5,
       0,     0,    20,     0,   136,    45,    45,     5,     0,     0,
       0,    45,     0,    73,    45,    45,     5,    52,     5,     0,
       5,     0,     5,     5,    61,     0,     0,   114,     0,     5,
      18,     0,     5,     5,     0,    55,     5,     0,     5,     0,
     118,     0,     5,     0,     0,   119,     0,     0,    92,     0,
       5,    46,    46,    11,     0,     0,    63,    85,     5,     0,
     124,   134,   128,   126,     0,   120,   122,   125,     0,   134,
     130,   132,    46,   117,   115,     5,     0,     0,     0,     0,
       0,     0,    19,     0,    70,     0,     0,    73,     0,     0,
       0,     0,   127,     0,     0,     5,     0,     0,     5,     0,
       0,    90,     0,     5,     0,     0,   134,     0,     0,     0,
       0,     0,     5,     0,     0,    73,    73,    73,     0,    73,
      62,    86,     0,   109,   111,    88,   107,     0,     0,   121,
      46,     0,   131,     0,   116,     0,    92,    99,     0,     0,
       0,     0,     0,     5,    45,     0,     5,     0,   100,    19,
       0,     0,     0,     0,    22,     0,    87,   110,     0,   134,
     123,     0,     5,   133,     0,     5,     0,     0,     0,     0,
      79,     0,     5,   134,   106,     0,     0,     0,    46,     5,
       5,    57,   108,     0,    64,    45,    91,     0,    82,    83,
       0,     0,    46,     0,     0,     0,     0,     0,     0,    20,
       5,    72,    71,     5,   129,     5,    45,    80,     0,   101,
      81,     0,     0,     0,     0,     0,    20,     5,    66,    53,
       0,     5,     0,     0,    45,     0,     0,     0,     0,    45,
      45,     5,    94,     0,    46,     0,     0,     0,     0,     5,
       0,    45,    45,     5,     5,     5,    93,    46,   101,    73,
      45,    45,     0,     0,    46,     0,     5,     5,    98,    46,
      46,     5,     0,    45,     0,     5,     5,    45,   103,     5,
      46,    46,     0,     0,    65,     0,    46,    46,    46,     5,
      95,   105,   106,     0,     0,     5,     0,   101,    46,   104,
       0,     0,    67,     0,   102,     0,     5,     5,     0,     0,
      97,    96,     0,     0,     0,     0,    73,     0,     0,     0,
      46,     0,     5,     0,    68,    73,     0,    46,     5,    69
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -424,  -424,     0,   820,   530,   443,  -424,  -424,   178,    63,
    -273,  -330,  -424,  -112,  -168,  -424,   -60,   -95,  -424,   815,
     -34,    20,  -424,  -424,   647,   -94,   -10,  -251,  -161,  -424,
    -424,  -423,  -424,   403,  -424,  -385,   112,   214,   218,   308,
     348,   584,  -303,  -424,   472,  -404,  -424,   395,   425,  -424,
      11,   414,   -86,  -424,   -23
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,   466,     4,    66,   180,   135,   264,   209,   343,
     289,   337,     9,    32,    34,    63,    58,   113,   176,    10,
     569,   290,    30,   125,   185,    22,    35,    69,   195,    70,
      71,   438,   285,   368,   369,   292,   379,   555,   525,   455,
     456,   196,   316,   430,   339,   372,   395,   396,   374,   400,
     106,   139,   265,   141,   115
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
       3,   144,   350,    81,   177,    50,   140,    85,   332,    13,
      14,   311,    94,   241,   471,    19,   297,    21,    33,   240,
     431,   459,     1,   557,    27,    28,    29,   183,    49,     1,
      82,    42,     1,     6,   207,   208,   191,   302,   475,   208,
     356,    52,    73,   163,   164,     1,   303,   488,   -60,   422,
      68,   199,   201,    74,    86,     7,   147,    87,    79,    80,
     423,   -75,   155,   156,   157,   158,    84,   427,   403,   147,
       8,     1,   256,   123,   207,   208,   256,   116,   131,    89,
      11,   121,    88,    15,   159,   131,   354,   114,    83,   168,
      12,   160,   161,   162,   163,   164,   357,   129,   131,   367,
     -76,   238,   301,   422,   142,    16,    33,     8,    77,    78,
     516,   381,   382,   404,    41,   147,     1,   386,    20,   181,
      18,   192,   266,   114,   119,   120,   187,   464,   147,   414,
     566,   550,   131,   114,    54,    55,    56,   452,   328,   444,
      23,   331,   114,   230,   131,   582,   541,   197,   470,   233,
     234,   235,   236,   237,    24,     1,   474,   131,   453,   454,
      25,   523,   536,   305,   475,   208,    26,   453,   454,   308,
     207,   208,   298,   299,    57,   267,    31,   114,   239,   170,
     171,   158,   361,   114,   114,   114,   114,   114,    44,    92,
     249,   313,   251,   252,    93,   155,   156,   157,   158,   547,
     155,   156,   157,   158,   529,   581,   506,   160,   161,   162,
     163,   164,   270,   475,   208,    46,   561,   159,   131,   307,
     155,   132,   159,   158,   160,   161,   162,   163,   164,   160,
     161,   162,   163,   164,   277,    43,   172,   173,   275,   174,
     175,   514,   278,   131,   280,   281,    45,   165,   284,   160,
     161,   162,   163,   164,   291,   228,   448,    36,   531,   532,
      37,    47,   229,    38,    39,    33,   197,    68,   126,   127,
     376,    33,   581,    40,   131,    48,    96,   306,   231,   548,
     207,   208,   309,   310,   481,   482,   483,    97,   485,   108,
     109,    51,   152,    53,   110,    59,   312,   114,   377,   111,
     323,   352,   353,   387,   174,   175,   388,   359,   340,    64,
     362,   363,    65,    98,    99,   287,   288,   320,   112,   100,
      75,   101,   439,   102,    67,   155,   156,   157,   158,   347,
     206,    72,   207,   208,   103,   104,    76,    68,   207,   208,
     604,    90,   105,   405,   406,    91,   364,   159,   365,    96,
      68,   472,   371,   373,   160,   161,   162,   163,   164,   378,
     137,    95,    68,    68,   622,   152,   384,   272,    68,   108,
     167,   118,   398,   117,   110,    60,    61,    62,   122,   111,
      68,   124,   397,   128,   434,   435,    98,   436,   420,   412,
     133,   644,   100,   136,   101,   143,   102,   649,   112,   134,
      96,   415,   416,   453,   454,   291,   145,   103,   104,   148,
     517,   137,   149,   553,   554,   437,   166,   533,   594,   169,
     440,   441,   429,   179,   155,   371,   157,   158,   373,   160,
     161,   162,   163,   164,   537,   434,   435,    98,   436,   184,
     502,   155,   186,   100,   158,   101,   159,   102,   172,   173,
     182,   174,   175,   160,   161,   162,   163,   164,   103,   104,
     592,   593,   188,   159,   475,   208,   437,   567,   397,   131,
     160,   161,   162,   163,   164,   638,   504,   412,   446,   447,
     492,   535,   583,   189,   646,   157,   158,   172,   173,   107,
     174,   175,    68,   390,   391,   291,   232,   392,   194,   344,
     345,   130,   551,   393,   210,   159,   605,   193,   212,    68,
      68,   146,   160,   161,   162,   163,   164,   150,   151,   153,
     172,   173,   394,   174,   175,   574,   575,   211,   530,   274,
      68,   178,   215,   549,   243,   371,   244,   586,   587,   245,
     248,   250,   539,   253,   254,   467,   595,   596,   263,   255,
     273,   198,   200,   229,   478,   276,   279,   390,   489,   213,
     282,   392,   214,   609,   286,   304,   314,   393,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   315,
     318,   324,   325,   326,   578,   501,   394,   329,   327,   330,
     334,    68,    96,   333,   341,   335,   242,   591,   336,   342,
     351,   346,   247,   137,   598,   348,   349,   355,   152,   602,
     603,   358,   360,   366,   522,    68,   257,   259,   261,   227,
     611,   612,   380,   383,   268,   269,   615,   616,   617,    98,
      99,   375,   385,   402,   413,   100,   418,   101,   625,   102,
     419,   421,    68,   424,   425,   426,   428,   432,    68,   433,
     103,   104,   443,   445,   442,   449,   450,    96,   138,   562,
     642,   457,   458,   564,   460,   461,   463,   648,    97,   468,
     469,   473,   294,   576,   295,   476,   296,   477,   480,   479,
     487,   584,   488,   484,   486,   588,   589,   590,   491,   494,
     497,   498,   499,   507,    98,    99,   513,   520,   600,   601,
     100,   500,   101,   317,   102,   258,   508,   607,   608,    96,
     509,   610,   321,   322,   510,   103,   104,   521,   407,   511,
      97,   618,   515,   105,   408,   317,    96,   518,   409,   410,
     519,   524,   534,   540,   538,   543,   556,    97,   630,   631,
     552,   558,   128,   563,   411,   565,    98,    99,   568,   570,
     571,    96,   100,   572,   101,   573,   102,   260,   577,   579,
     580,   597,    97,    98,    99,   370,   585,   103,   104,   100,
     599,   101,   613,   102,   262,   105,   606,   614,   620,   621,
     407,   623,    96,   626,   103,   104,   496,   401,    98,    99,
     409,   410,   105,   137,   100,   627,   101,   629,   102,   628,
      96,   632,   634,   633,   128,   635,   411,   636,   637,   103,
     104,    97,   639,   643,   645,   640,   641,   105,   647,    98,
      99,     5,   319,   451,    96,   100,   417,   101,    17,   102,
     619,   624,   542,   246,   370,   137,   512,    98,   399,   293,
     103,   104,   389,   100,   317,   101,   465,   102,   138,   526,
     527,   200,   490,   462,     0,     0,     0,     0,   103,   104,
       0,    98,   503,     0,     0,     0,   105,   100,   154,   101,
       0,   102,     0,     0,     0,   493,     0,   155,   156,   157,
     158,     0,   103,   104,     0,     0,   190,     0,     0,     0,
     138,   505,     0,     0,     0,   155,   156,   157,   158,   159,
     155,   156,   157,   158,     0,     0,   160,   161,   162,   163,
     164,     0,     0,   155,   156,   157,   158,   159,     0,     0,
     528,   317,   159,     0,   160,   161,   162,   163,   164,   160,
     161,   162,   163,   164,     0,   159,   155,   156,   157,   158,
     544,   545,   160,   161,   162,   163,   164,     0,   155,   156,
     157,   158,   283,     0,     0,     0,     0,     0,   159,     0,
     155,   156,   157,   158,     0,   160,   161,   162,   163,   164,
     159,     0,     0,     0,     0,   300,     0,   160,   161,   162,
     163,   164,   159,   155,   156,   157,   158,   495,     0,   160,
     161,   162,   163,   164,     0,   155,   156,   157,   158,   546,
       0,     0,   202,     0,     0,   159,   203,   204,   155,   156,
     157,   158,   160,   161,   162,   163,   205,   159,     0,     0,
       0,   216,     0,     0,   160,   161,   162,   163,   164,     0,
     159,     0,     0,   216,     0,     0,     0,   160,   161,   162,
     163,   164,     0,     0,   559,     0,   271,   155,   156,   157,
     158,     0,     0,     0,     0,     0,   560,     0,     0,   155,
     156,   157,   158,   206,     0,   155,   156,   157,   158,   159,
     338,   155,   156,   157,   158,     0,   160,   161,   162,   163,
     164,   159,     0,     0,     0,     0,     0,   159,   160,   161,
     162,   163,   164,   159,   160,   161,   162,   163,   164,     0,
     160,   161,   162,   163,   164,   155,   156,   157,   158,     0,
     155,   156,   157,   158,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   202,     0,     0,   159,   203,   204,
       0,     0,   159,     0,   160,   161,   162,   163,   205,   160,
     161,   162,   163,   164
};

static const yytype_int16 yycheck[] =
{
       0,    95,   332,    63,   116,    39,    92,    67,   311,     9,
      10,   284,    72,   181,   437,    15,   267,    17,    28,   180,
     405,   425,     3,    62,    24,    25,    26,   122,    38,     3,
      22,    31,     3,     0,    43,    44,   131,    52,    43,    44,
      26,    41,    52,    75,    76,     3,    61,    86,    18,    51,
      50,   137,   138,    53,    24,     4,    51,    27,    58,    59,
      62,    31,    43,    44,    45,    46,    66,    62,    37,    51,
      19,     3,    81,    83,    43,    44,    81,    77,    80,    68,
      52,    81,    52,     5,    65,    80,   337,    76,    80,   112,
      52,    72,    73,    74,    75,    76,    82,    86,    80,   350,
      31,    82,   270,    51,    93,    21,   116,    19,    82,    83,
     495,   362,   363,    82,    85,    51,     3,   368,    52,   119,
       7,    52,   208,   112,    82,    83,   126,   430,    51,   380,
     553,   535,    80,   122,    12,    13,    14,    30,   306,   412,
       6,   309,   131,   166,    80,   568,    30,   136,    84,   172,
     173,   174,   175,   176,     5,     3,    35,    80,    51,    52,
      80,    84,    35,   275,    43,    44,    80,    51,    52,   281,
      43,    44,    15,    16,    52,   209,    52,   166,   178,    15,
      16,    46,   343,   172,   173,   174,   175,   176,    83,    34,
     190,   286,   192,   193,    39,    43,    44,    45,    46,   529,
      43,    44,    45,    46,   507,    35,   479,    72,    73,    74,
      75,    76,   212,    43,    44,    83,   546,    65,    80,   279,
      43,    83,    65,    46,    72,    73,    74,    75,    76,    72,
      73,    74,    75,    76,    82,    81,    72,    73,   238,    75,
      76,   492,   242,    80,   244,   245,    81,    84,   248,    72,
      73,    74,    75,    76,   254,    53,   417,    17,   509,   510,
      20,    52,    60,    23,    24,   275,   255,   267,    82,    83,
     356,   281,    35,    33,    80,    52,    14,   277,    84,   530,
      43,    44,   282,   283,   445,   446,   447,    25,   449,    51,
      52,    52,    30,    82,    56,    82,   285,   286,   358,    61,
     300,   335,   336,    82,    75,    76,    85,   341,   318,     5,
     344,   345,     5,    51,    52,     6,     7,   297,    80,    57,
      53,    59,   408,    61,    83,    43,    44,    45,    46,   329,
      41,    83,    43,    44,    72,    73,    80,   337,    43,    44,
     591,    18,    80,    82,    83,    31,   346,    65,   348,    14,
     350,   437,   352,   353,    72,    73,    74,    75,    76,   359,
      25,     6,   362,   363,   615,    30,   366,    85,   368,    51,
      52,    18,   372,    62,    56,     8,     9,    10,    80,    61,
     380,     7,   371,    52,    49,    50,    51,    52,   388,   378,
      66,   642,    57,    80,    59,    83,    61,   648,    80,    19,
      14,   381,   382,    51,    52,   405,    80,    72,    73,    80,
     496,    25,    58,    36,    37,    80,    80,   511,   579,    81,
     409,   410,   402,     4,    43,   425,    45,    46,   428,    72,
      73,    74,    75,    76,   520,    49,    50,    51,    52,    81,
     474,    43,     6,    57,    46,    59,    65,    61,    72,    73,
      62,    75,    76,    72,    73,    74,    75,    76,    72,    73,
      36,    37,    62,    65,    43,    44,    80,   553,   457,    80,
      72,    73,    74,    75,    76,   636,   476,   466,   415,   416,
     460,   515,   568,    66,   645,    45,    46,    72,    73,    75,
      75,    76,   492,    51,    52,   495,    81,    55,    52,   321,
     322,    87,   536,    61,     8,    65,   592,    62,    80,   509,
     510,    97,    72,    73,    74,    75,    76,   103,   104,   105,
      72,    73,    80,    75,    76,   559,   560,    62,   508,    81,
     530,   117,    62,   533,    81,   535,    82,   571,   572,    80,
      62,    81,   522,    82,    81,   433,   580,   581,    24,    85,
      67,   137,   138,    60,   442,    82,    21,    51,    52,   145,
      80,    55,   148,   597,    80,    51,    11,    61,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    11,
      32,    81,    81,    81,   564,   473,    80,    82,    81,    81,
      81,   591,    14,    66,    24,    80,   182,   577,    80,    18,
      62,    82,   188,    25,   584,    82,    81,    61,    30,   589,
     590,    83,    41,    82,   502,   615,   202,   203,   204,   205,
     600,   601,    82,    18,   210,   211,   606,   607,   608,    51,
      52,    52,    18,    81,    18,    57,    18,    59,   618,    61,
      52,    26,   642,    30,    85,    81,    85,    62,   648,    82,
      72,    73,    83,    31,    82,    20,    82,    14,    80,   547,
     640,    67,    62,   551,    82,    67,     6,   647,    25,    80,
      80,    35,   258,   561,   260,     5,   262,     8,    66,    62,
      51,   569,    86,    82,    82,   573,   574,   575,    67,    11,
      52,    52,    48,    62,    51,    52,    51,    43,   586,   587,
      57,    81,    59,   289,    61,    62,    82,   595,   596,    14,
      82,   599,   298,   299,    82,    72,    73,    18,    28,    82,
      25,   609,    80,    80,    34,   311,    14,    81,    38,    39,
      81,    26,    81,    48,    34,    18,    62,    25,   626,   627,
      82,    38,    52,    81,    54,    18,    51,    52,    34,    18,
      67,    14,    57,    67,    59,    82,    61,    62,    82,    31,
      35,    35,    25,    51,    52,   351,    34,    72,    73,    57,
      82,    59,    18,    61,    62,    80,    82,    18,    40,    40,
      28,    18,    14,    82,    72,    73,    34,   373,    51,    52,
      38,    39,    80,    25,    57,    82,    59,    18,    61,    34,
      14,    82,    18,    34,    52,    82,    54,    31,    18,    72,
      73,    25,    34,    18,    31,    82,    82,    80,    82,    51,
      52,     1,   292,   420,    14,    57,   383,    59,    13,    61,
     612,   617,   524,   186,   420,    25,   488,    51,    52,   255,
      72,    73,   370,    57,   430,    59,   432,    61,    80,    15,
      16,   437,   457,   428,    -1,    -1,    -1,    -1,    72,    73,
      -1,    51,    52,    -1,    -1,    -1,    80,    57,    16,    59,
      -1,    61,    -1,    -1,    -1,   461,    -1,    43,    44,    45,
      46,    -1,    72,    73,    -1,    -1,    29,    -1,    -1,    -1,
      80,   477,    -1,    -1,    -1,    43,    44,    45,    46,    65,
      43,    44,    45,    46,    -1,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    43,    44,    45,    46,    65,    -1,    -1,
     506,   507,    65,    -1,    72,    73,    74,    75,    76,    72,
      73,    74,    75,    76,    -1,    65,    43,    44,    45,    46,
     526,   527,    72,    73,    74,    75,    76,    -1,    43,    44,
      45,    46,    82,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      43,    44,    45,    46,    -1,    72,    73,    74,    75,    76,
      65,    -1,    -1,    -1,    -1,    82,    -1,    72,    73,    74,
      75,    76,    65,    43,    44,    45,    46,    82,    -1,    72,
      73,    74,    75,    76,    -1,    43,    44,    45,    46,    82,
      -1,    -1,    62,    -1,    -1,    65,    66,    67,    43,    44,
      45,    46,    72,    73,    74,    75,    76,    65,    -1,    -1,
      -1,    81,    -1,    -1,    72,    73,    74,    75,    76,    -1,
      65,    -1,    -1,    81,    -1,    -1,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    40,    -1,    81,    43,    44,    45,
      46,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    43,
      44,    45,    46,    41,    -1,    43,    44,    45,    46,    65,
      42,    43,    44,    45,    46,    -1,    72,    73,    74,    75,
      76,    65,    -1,    -1,    -1,    -1,    -1,    65,    72,    73,
      74,    75,    76,    65,    72,    73,    74,    75,    76,    -1,
      72,    73,    74,    75,    76,    43,    44,    45,    46,    -1,
      43,    44,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    62,    -1,    -1,    65,    66,    67,
      -1,    -1,    65,    -1,    72,    73,    74,    75,    76,    72,
      73,    74,    75,    76
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    88,    89,    90,    90,     0,     4,    19,    99,
     106,    52,    52,    89,    89,     5,    21,   106,     7,    89,
      52,    89,   112,     6,     5,    80,    80,    89,    89,    89,
     109,    52,   100,   113,   101,   113,    17,    20,    23,    24,
      33,    85,    89,    81,    83,    81,    83,    52,    52,   113,
     107,    52,    89,    82,    12,    13,    14,    52,   103,    82,
       8,     9,    10,   102,     5,     5,    91,    83,    89,   114,
     116,   117,    83,   113,    89,    53,    80,    82,    83,    89,
      89,   103,    22,    80,    89,   103,    24,    27,    52,   137,
      18,    31,    34,    39,   103,     6,    14,    25,    51,    52,
      57,    59,    61,    72,    73,    80,   137,   138,    51,    52,
      56,    61,    80,   104,   137,   141,    89,    62,    18,    82,
      83,    89,    80,   113,     7,   110,    82,    83,    52,   137,
     138,    80,    83,    66,    19,    93,    80,    25,    80,   138,
     139,   140,   137,    83,   112,    80,   138,    51,    80,    58,
     138,   138,    30,   138,    16,    43,    44,    45,    46,    65,
      72,    73,    74,    75,    76,    84,    80,    52,   141,    81,
      15,    16,    72,    73,    75,    76,   105,   100,   138,     4,
      92,    89,    62,   104,    81,   111,     6,    89,    62,    66,
      29,   104,    52,    62,    52,   115,   128,   137,   138,   139,
     138,   139,    62,    66,    67,    76,    41,    43,    44,    95,
       8,    62,    80,   138,   138,    62,    81,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,    53,    60,
     141,    84,    81,   141,   141,   141,   141,   141,    82,    89,
     115,   101,   138,    81,    82,    80,   111,   138,    62,    89,
      81,    89,    89,    82,    81,    85,    81,   138,    62,   138,
      62,   138,    62,    24,    94,   139,   139,   107,   138,   138,
      89,    81,    85,    67,    81,    89,    82,    82,    89,    21,
      89,    89,    80,    82,    89,   119,    80,     6,     7,    97,
     108,    89,   122,   128,   138,   138,   138,   114,    15,    16,
      82,   101,    52,    61,    51,   100,    89,   103,   100,    89,
      89,    97,   137,   104,    11,    11,   129,   138,    32,    91,
     108,   138,   138,    89,    81,    81,    81,    81,   101,    82,
      81,   101,   129,    66,    81,    80,    80,    98,    42,   131,
     113,    24,    18,    96,    95,    95,    82,    89,    82,    81,
      98,    62,   107,   107,   114,    61,    26,    82,    83,   107,
      41,   115,   107,   107,    89,    89,    82,   114,   120,   121,
     138,    89,   132,    89,   135,    52,   139,   103,    89,   123,
      82,   114,   114,    18,    89,    18,   114,    82,    85,   131,
      51,    52,    55,    61,    80,   133,   134,   137,    89,    52,
     136,   138,    81,    37,    82,    82,    83,    28,    34,    38,
      39,    54,   137,    18,   114,   108,   108,    92,    18,    52,
      89,    26,    51,    62,    30,    85,    81,    62,    85,   108,
     130,   122,    62,    82,    49,    50,    52,    80,   118,   139,
     137,   137,    82,    83,    97,    31,    96,    96,   115,    20,
      82,   120,    30,    51,    52,   126,   127,    67,    62,   132,
      82,    67,   135,     6,   129,   138,    89,   123,    80,    80,
      84,   118,   139,    35,    35,    43,     5,     8,   123,    62,
      66,   115,   115,   115,    82,   115,    82,    51,    86,    52,
     134,    67,   108,   138,    11,    82,    34,    52,    52,    48,
      81,   123,   107,    52,    89,   138,    97,    62,    82,    82,
      82,    82,   127,    51,   114,    80,   122,   139,    81,    81,
      43,    18,   123,    84,    26,   125,    15,    16,   138,   129,
     108,   114,   114,   112,    81,   107,    35,   139,    34,   108,
      48,    30,   126,    18,   138,   138,    82,    98,   114,    89,
     132,   107,    82,    36,    37,   124,    62,    62,    38,    40,
      40,    98,   123,    81,   123,    18,   118,   139,    34,   107,
      18,    67,    67,    82,   107,   107,   123,    82,   108,    31,
      35,    35,   118,   139,   123,    34,   107,   107,   123,   123,
     123,   108,    36,    37,   115,   107,   107,    35,   108,    82,
     123,   123,   108,   108,   114,   139,    82,   123,   123,   107,
     123,   108,   108,    18,    18,   108,   108,   108,   123,   125,
      40,    40,   114,    18,   124,   108,    82,    82,    34,    18,
     123,   123,    82,    34,    18,    82,    31,    18,   115,    34,
      82,    82,   108,    18,   114,    31,   115,    82,   108,   114
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    87,    88,    88,    88,    89,    89,    90,    90,    91,
      91,    92,    92,    93,    93,    94,    94,    95,    96,    97,
      98,    99,    99,   100,   100,   100,   100,   101,   101,   101,
     101,   102,   102,   102,   103,   103,   103,   103,   103,   104,
     104,   104,   105,   105,   106,   107,   108,   109,   109,   109,
     109,   109,   109,   109,   110,   110,   111,   112,   113,   113,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   115,   115,   116,   116,   117,   117,   118,
     118,   118,   118,   118,   119,   120,   120,   120,   121,   122,
     122,   122,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   124,   124,   124,   125,   125,   125,   126,   126,   127,
     127,   127,   128,   128,   129,   129,   129,   130,   131,   131,
     132,   132,   133,   133,   134,   134,   134,   134,   134,   134,
     135,   135,   135,   136,   137,   137,   137,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   139,   139,   139,   139,   139,   140,   140,   140,   140,
     140,   140,   141,   141,   141,   141,   141,   141,   141,   141,
     141,   141
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     5,     3,     3,     0,     1,     1,     2,     0,
       1,     0,     1,     0,     1,     0,     1,     2,     2,     0,
       0,    15,    23,     7,     9,     6,     4,     5,     7,     8,
      10,     1,     1,     1,     1,     5,     1,     4,     1,     3,
       1,     3,     1,     1,    15,     0,     0,     0,     7,    10,
      10,     9,    12,    20,     0,     8,     0,     0,     2,     4,
       1,     9,    13,    11,    15,    21,    16,    23,    31,    35,
      11,    15,    15,     0,     1,     1,     3,     1,     3,     3,
       5,     5,     4,     4,     0,     2,     4,     5,     4,     1,
       7,    10,     1,     9,     8,    12,    15,    15,    10,     4,
       4,     0,     7,     4,     8,     7,     0,     1,     3,     1,
       2,     1,     1,     3,     3,     5,     7,     0,     0,     3,
       2,     4,     1,     4,     1,     1,     1,     2,     1,     6,
       2,     4,     2,     4,     1,     4,     7,     1,     1,     1,
       1,     2,     2,     6,     3,     2,     2,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     4,     6,     6,
       3,     1,     3,     3,     3,     2,     3,     3,     4,     3,
       4,     4,     1,     1,     1,     3,     3,     3,     3,     3,
       4,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 757 "vhd2vl.y" /* yacc.c:1646  */
    {
        slist *sl;
          sl=output_timescale((yyvsp[-4].sl));
          sl=addsl(sl,(yyvsp[-3].sl));
          sl=addsl(sl,(yyvsp[-2].sl));
          sl=addsl(sl,(yyvsp[-1].sl));
          sl=addsl(sl,(yyvsp[0].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        }
#line 2459 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 772 "vhd2vl.y" /* yacc.c:1646  */
    {
        slist *sl;
          sl=addsl((yyvsp[-2].sl),(yyvsp[-1].sl));
          sl=addsl(sl,(yyvsp[0].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        }
#line 2472 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 780 "vhd2vl.y" /* yacc.c:1646  */
    {
        slist *sl;
          sl=addsl((yyvsp[-2].sl),(yyvsp[-1].sl));
          sl=addsl(sl,(yyvsp[0].sl));
          sl=addtxt(sl,"\nendmodule\n");
          slprint(sl);
          (yyval.n)=0;
        }
#line 2485 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 791 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=NULL; }
#line 2491 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 792 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=(yyvsp[0].sl); }
#line 2497 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 795 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addtxt(indents[indent],(yyvsp[0].txt));}
#line 2503 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 796 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
           sl=addtxt(indents[indent],(yyvsp[-1].txt));
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));}
#line 2512 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 802 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.txt)=NULL;}
#line 2518 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 804 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.txt)=NULL;}
#line 2524 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 806 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.txt)=NULL;}
#line 2530 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 808 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.txt)=NULL;}
#line 2536 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 815 "vhd2vl.y" /* yacc.c:1646  */
    {skipRem = 1;}
#line 2542 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 816 "vhd2vl.y" /* yacc.c:1646  */
    {skipRem = 0;}
#line 2548 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 820 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl;
            sglist *p;
              sl=addtxt(NULL,"\nmodule ");
              sl=addtxt(sl,(yyvsp[-13].txt)); /* NAME */
              /* Add the signal list */
              sl=emit_io_list(sl);
              sl=addsl(sl,(yyvsp[-8].sl)); /* rem */
              sl=addsl(sl,(yyvsp[-7].sl)); /* portlist */
              sl=addtxt(sl,"\n");
              p=io_list;
              if (vlog_ver == 0) {
                do{
                sl=addptxt(sl,&(p->type));
                /*sl=addtxt(sl,p->type);*/
                sl=addpar(sl,p->range);
                sl=addtxt(sl,p->name);
                /* sl=addpost(sl,p->range); */
                sl=addtxt(sl,";\n");
                p=p->next;
                } while(p!=NULL);
              }
              sl=addtxt(sl,"\n");
              sl=addsl(sl,(yyvsp[-4].sl)); /* rem2 */
              (yyval.sl)=addtxt(sl,"\n");
            }
#line 2579 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 847 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl;
            sglist *p;
              if (0) fprintf(stderr,"matched ENTITY GENERIC\n");
              sl=addtxt(NULL,"\nmodule ");
              sl=addtxt(sl,(yyvsp[-21].txt)); /* NAME */
              sl=emit_io_list(sl);
              sl=addsl(sl,(yyvsp[-16].sl));  /* rem */
              sl=addsl(sl,(yyvsp[-15].sl));  /* genlist */
              sl=addsl(sl,(yyvsp[-12].sl)); /* rem */
              sl=addsl(sl,(yyvsp[-8].sl)); /* rem */
              sl=addsl(sl,(yyvsp[-7].sl)); /* portlist */
              sl=addtxt(sl,"\n");
              p=io_list;
              if (vlog_ver == 0) {
                do{
                sl=addptxt(sl,&(p->type));
                /*sl=addtxt(sl,p->type);*/
                sl=addpar(sl,p->range);
                sl=addtxt(sl,p->name);
                sl=addtxt(sl,";\n");
                p=p->next;
                } while(p!=NULL);
              }
              sl=addtxt(sl,"\n");
              sl=addsl(sl,(yyvsp[-4].sl)); /* rem2 */
              (yyval.sl)=addtxt(sl,"\n");
            }
#line 2612 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 878 "vhd2vl.y" /* yacc.c:1646  */
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[-4].v)); /* type */
            p=(yyvsp[-6].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,"=");
              sl=addsl(sl, (yyvsp[-1].e)->sl); /* expr */
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* rem */
          } else {
            (yyval.sl)=NULL;
          }
         }
#line 2637 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 899 "vhd2vl.y" /* yacc.c:1646  */
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[-6].v)); /* type */
            p=(yyvsp[-8].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,"=");
              sl=addsl(sl, (yyvsp[-3].e)->sl); /* expr */
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[-1].sl)); /* rem */
            (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* genlist */
          } else {
            (yyval.sl)=NULL;
          }
         }
#line 2663 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 921 "vhd2vl.y" /* yacc.c:1646  */
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[-3].v)); /* type */
            p=(yyvsp[-5].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[-1].sl)); /* rem */
            (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* genlist */
          } else {
            (yyval.sl)=NULL;
          }
         }
#line 2687 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 941 "vhd2vl.y" /* yacc.c:1646  */
    {
          if(dolist){
            slist *sl;
            sglist *p;
            sl=addtxt(NULL,"parameter");
            sl=addpar(sl,(yyvsp[-1].v)); /* type */
            p=(yyvsp[-3].sg);
            for(;;){
              sl=addtxt(sl,p->name);
              sl=addtxt(sl,";\n");
              p=p->next;
              if(p==NULL) break;
            }
            (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* rem */
          } else {
            (yyval.sl)=NULL;
          }
         }
#line 2710 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 962 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl;

              if(dolist){
                io_list=NULL;
                sl=setup_port((yyvsp[-4].sg),(yyvsp[-2].n),(yyvsp[-1].v));  /* modifies io_list global */
                (yyval.sl)=addsl(sl,(yyvsp[0].sl));
              } else{
                free((yyvsp[0].sl));
                free((yyvsp[-1].v));
              }
            }
#line 2727 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 975 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl;

              if(dolist){
                sl=setup_port((yyvsp[-6].sg),(yyvsp[-4].n),(yyvsp[-3].v));  /* modifies io_list global */
                sl=addsl(sl,(yyvsp[-1].sl));
                (yyval.sl)=addsl(sl,(yyvsp[0].sl));
              } else{
                free((yyvsp[-1].sl));
                free((yyvsp[-3].v));
              }
            }
#line 2744 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 988 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl;
              fprintf(stderr,"Warning on line %d: "
                "port default initialization ignored\n",lineno);
              if(dolist){
                io_list=NULL;
                sl=setup_port((yyvsp[-7].sg),(yyvsp[-5].n),(yyvsp[-4].v));  /* modifies io_list global */
                (yyval.sl)=addsl(sl,(yyvsp[0].sl));
              } else{
                free((yyvsp[0].sl));
                free((yyvsp[-4].v));
              }
            }
#line 2762 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 1002 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl;
              fprintf(stderr,"Warning on line %d: "
                "port default initialization ignored\n",lineno);
              if(dolist){
                sl=setup_port((yyvsp[-9].sg),(yyvsp[-7].n),(yyvsp[-6].v));  /* modifies io_list global */
                sl=addsl(sl,(yyvsp[-1].sl));
                (yyval.sl)=addsl(sl,(yyvsp[0].sl));
              } else{
                free((yyvsp[-1].sl));
                free((yyvsp[-6].v));
              }
            }
#line 2780 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 1017 "vhd2vl.y" /* yacc.c:1646  */
    { (yyval.n)=0;}
#line 2786 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 1018 "vhd2vl.y" /* yacc.c:1646  */
    { (yyval.n)=1; }
#line 2792 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 1019 "vhd2vl.y" /* yacc.c:1646  */
    { (yyval.n)=2; }
#line 2798 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 1022 "vhd2vl.y" /* yacc.c:1646  */
    {
                (yyval.v)=new_vrange(tSCALAR);
              }
#line 2806 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 1025 "vhd2vl.y" /* yacc.c:1646  */
    {
                fprintf(stderr,"Warning on line %d: integer range ignored\n",lineno);
                (yyval.v)=new_vrange(tSCALAR);
                (yyval.v)->nlo = addtxt(NULL,"0");
                (yyval.v)->nhi = addtxt(NULL,"31");
              }
#line 2817 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 1031 "vhd2vl.y" /* yacc.c:1646  */
    {
                (yyval.v)=new_vrange(tSCALAR);
                (yyval.v)->nlo = addtxt(NULL,"0");
                (yyval.v)->nhi = addtxt(NULL,"31");
              }
#line 2827 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 1036 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.v)=(yyvsp[-1].v);}
#line 2833 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 1037 "vhd2vl.y" /* yacc.c:1646  */
    {
              sglist *sg;

                sg=lookup(type_list,(yyvsp[0].txt));
                if(sg)
                  (yyval.v)=sg->range;
                else{
                  fprintf(stderr,"Undefined type '%s' on line %d\n",(yyvsp[0].txt),lineno);
                  YYABORT;
                }
              }
#line 2849 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 1051 "vhd2vl.y" /* yacc.c:1646  */
    {
              (yyval.v)=new_vrange(tVRANGE);
              (yyval.v)->nhi=(yyvsp[-2].e)->sl;
              (yyval.v)->nlo=(yyvsp[0].e)->sl;
              (yyval.v)->sizeval = -1; /* undefined size */
              /* calculate the width of this vrange */
              if ((yyvsp[-2].e)->op == 'n' && (yyvsp[0].e)->op == 'n') {
                if ((yyvsp[-1].n)==-1) { /* (nhi:natural downto nlo:natural) */
                  (yyval.v)->sizeval = (yyvsp[-2].e)->value - (yyvsp[0].e)->value + 1;
                } else {      /* (nhi:natural to     nlo:natural) */
                  (yyval.v)->sizeval = (yyvsp[0].e)->value - (yyvsp[-2].e)->value + 1;
                }
              } else {
                /* make an expression to calculate the width of this vrange:
                 * create an expression that calculates:
                 *   size expr = (simple_expr1) - (simple_expr2) + 1
                 */
                expdata *size_expr1  = xmalloc(sizeof(expdata));
                expdata *size_expr2  = xmalloc(sizeof(expdata));
                expdata *diff12  = xmalloc(sizeof(expdata));
                expdata *plusone = xmalloc(sizeof(expdata));
                expdata *finalexpr = xmalloc(sizeof(expdata));
                size_expr1->sl = addwrap("(",(yyvsp[-2].e)->sl,")");
                size_expr2->sl = addwrap("(",(yyvsp[0].e)->sl,")");
                plusone->op='t';
                plusone->sl=addtxt(NULL,"1");
                if ((yyvsp[-1].n)==-1) {
                  /* (simple_expr1 downto simple_expr1) */
                  diff12 = addexpr(size_expr1,'-',"-",size_expr2);
                } else {
                  /* (simple_expr1   to   simple_expr1) */
                  diff12 = addexpr(size_expr2,'-',"-",size_expr1);
                }
                finalexpr = addexpr(diff12,'+',"+",plusone);
                finalexpr->sl = addwrap("(",finalexpr->sl,")");
                (yyval.v)->size_expr = finalexpr->sl;
              }
            }
#line 2892 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 1089 "vhd2vl.y" /* yacc.c:1646  */
    {
              (yyval.v)=new_vrange(tSUBSCRIPT);
              (yyval.v)->nlo=(yyvsp[0].e)->sl;
          }
#line 2901 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 1093 "vhd2vl.y" /* yacc.c:1646  */
    {
              /* lookup NAME and copy its vrange */
              sglist *sg = NULL;
              if((sg=lookup(io_list,(yyvsp[-2].txt)))==NULL) {
                sg=lookup(sig_list,(yyvsp[-2].txt));
              }
              if(sg) {
                (yyval.v) = sg->range;
              } else {
                fprintf(stderr,"Undefined range \"%s'range\" on line %d\n",(yyvsp[-2].txt),lineno);
                YYABORT;
              }
          }
#line 2919 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 1108 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.n)=-1;}
#line 2925 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 1109 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.n)=1;}
#line 2931 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 1114 "vhd2vl.y" /* yacc.c:1646  */
    {
               slist *sl;
                 sl=addsl((yyvsp[-9].sl),(yyvsp[-8].sl));
                 sl=addtxt(sl,"\n");
                 (yyval.sl)=addsl(sl,(yyvsp[-5].sl));
               }
#line 2942 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 1123 "vhd2vl.y" /* yacc.c:1646  */
    {indent= indent < MAXINDENT ? indent + 1 : indent;}
#line 2948 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 1126 "vhd2vl.y" /* yacc.c:1646  */
    {indent= indent > 0 ? indent - 1 : indent;}
#line 2954 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 1129 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=NULL;}
#line 2960 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 1130 "vhd2vl.y" /* yacc.c:1646  */
    {
            sglist *sg;
            slist *sl;

              sl=(yyvsp[-6].sl);
              sg=(yyvsp[-4].sg);
              for(;;){
                sg->type=wire;
                sg->range=(yyvsp[-2].v);
                sl=addptxt(sl,&(sg->type));
                sl=addpar(sl,(yyvsp[-2].v));
                sl=addtxt(sl,sg->name);
                sl=addpost(sl,(yyvsp[-2].v));
                sl=addtxt(sl,";");
                if(sg->next == NULL)
                  break;
                sl=addtxt(sl," ");
                sg=sg->next;
              }
              sg->next=sig_list;
              sig_list=(yyvsp[-4].sg);
              (yyval.sl)=addrem(sl,(yyvsp[0].sl));
            }
#line 2988 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 1153 "vhd2vl.y" /* yacc.c:1646  */
    {
            sglist *sg;
            slist *sl;

              sl=(yyvsp[-9].sl);
              sg=(yyvsp[-7].sg);
              for(;;){
                sg->type=wire;
                sg->range=(yyvsp[-5].v);
                sl=addptxt(sl,&(sg->type));
                sl=addpar(sl,(yyvsp[-5].v));
                sl=addtxt(sl,sg->name);
                sl=addpost(sl,(yyvsp[-5].v));
                sl=addtxt(sl," = ");
                sl=addsl(sl,(yyvsp[-2].e)->sl);
                sl=addtxt(sl,";");
                if(sg->next == NULL)
                  break;
                sl=addtxt(sl," ");
                sg=sg->next;
              }
              sg->next=sig_list;
              sig_list=(yyvsp[-7].sg);
              (yyval.sl)=addrem(sl,(yyvsp[0].sl));
            }
#line 3018 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 1178 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist * sl;
              sl=addtxt((yyvsp[-9].sl),"parameter ");
              sl=addtxt(sl,(yyvsp[-7].txt));
              sl=addtxt(sl," = ");
              sl=addsl(sl,(yyvsp[-2].e)->sl);
              sl=addtxt(sl,";");
              (yyval.sl)=addrem(sl,(yyvsp[0].sl));
            }
#line 3032 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 1187 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl, *sl2;
            sglist *p;
            int n,k;
              n=0;
              sl=NULL;
              p=(yyvsp[-3].sg);
              for(;;){
                sl=addtxt(sl,"  ");
                sl=addtxt(sl,p->name);
                sl=addtxt(sl," = ");
                sl=addval(sl,n++);
                p=p->next;
                if(p==NULL){
                  sl=addtxt(sl,";\n");
                  break;
                } else
                  sl=addtxt(sl,",\n");
              }
              n--;
              k=find_msb(n);
              sl2=addtxt(NULL,"parameter [");
              sl2=addval(sl2,k);
              sl2=addtxt(sl2,":0]\n");
              sl=addsl(sl2,sl);
              sl=addsl((yyvsp[-8].sl),sl);
              (yyval.sl)=addrem(sl,(yyvsp[0].sl));
              p=xmalloc(sizeof(sglist));
              p->name=(yyvsp[-6].txt);
              if(k>0) {
                p->range=new_vrange(tVRANGE);
                p->range->sizeval = k+1;
                p->range->nhi=addval(NULL,k);
                p->range->nlo=addtxt(NULL,"0");
              } else {
                p->range=new_vrange(tSCALAR);
              }
              p->next=type_list;
              type_list=p;
            }
#line 3077 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 1227 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl=NULL;
            sglist *p;
              (yyval.sl)=addrem(sl,(yyvsp[0].sl));
              p=xmalloc(sizeof(sglist));
              p->name=(yyvsp[-9].txt);
              p->range=(yyvsp[-2].v);
              p->range->xhi=(yyvsp[-5].v)->nhi;
              p->range->xlo=(yyvsp[-5].v)->nlo;
              p->next=type_list;
              type_list=p;
            }
#line 3094 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 1240 "vhd2vl.y" /* yacc.c:1646  */
    {
              (yyval.sl)=addsl((yyvsp[-19].sl),(yyvsp[0].sl)); /* a_decl, rem4 */
              free((yyvsp[-17].txt)); /* NAME */
              free((yyvsp[-10].sl)); /* rem2 */
              free((yyvsp[-6].sl));/* rem3 */
            }
#line 3105 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 1248 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.txt)=NULL;}
#line 3111 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 1249 "vhd2vl.y" /* yacc.c:1646  */
    {
             if (0) fprintf(stderr,"matched opt_generic\n");
             free((yyvsp[-4].sl));  /* rem */
             free((yyvsp[0].sl));  /* rem */
             (yyval.txt)=NULL;
            }
#line 3122 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 1257 "vhd2vl.y" /* yacc.c:1646  */
    {dolist = 0;}
#line 3128 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 1258 "vhd2vl.y" /* yacc.c:1646  */
    {dolist = 1;}
#line 3134 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1261 "vhd2vl.y" /* yacc.c:1646  */
    {
         sglist * sg;
           if(dolist){
             sg=xmalloc(sizeof(sglist));
             sg->name=(yyvsp[-1].txt);
             sg->next=NULL;
             (yyval.sg)=sg;
           } else{
             free((yyvsp[-1].txt));
             (yyval.sg)=NULL;
           }
           free((yyvsp[0].sl));
         }
#line 3152 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1274 "vhd2vl.y" /* yacc.c:1646  */
    {
         sglist * sg;
           if(dolist){
             sg=xmalloc(sizeof(sglist));
             sg->name=(yyvsp[-3].txt);
             sg->next=(yyvsp[0].sg);
             (yyval.sg)=sg;
           } else{
             free((yyvsp[-3].txt));
             (yyval.sg)=NULL;
           }
           free((yyvsp[-1].sl));
         }
#line 3170 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 1289 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addind((yyvsp[0].sl));}
#line 3176 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1291 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           sl=addsl((yyvsp[-8].sl),indents[indent]);
           sl=addtxt(sl,"assign ");
           sl=addsl(sl,(yyvsp[-7].ss)->sl);
           findothers((yyvsp[-7].ss),(yyvsp[-2].sl));
           free((yyvsp[-7].ss));
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-2].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3193 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 1303 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           sl=addsl((yyvsp[-12].sl),indents[indent]);
           sl=addtxt(sl,"assign ");
           sl=addsl(sl,(yyvsp[-10].ss)->sl);
           findothers((yyvsp[-10].ss),(yyvsp[-5].sl));
           free((yyvsp[-10].ss));
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-5].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[-3].sl));
         }
#line 3210 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1316 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
         sglist *sg;
         char *s;
           sl=addsl((yyvsp[-10].sl),indents[indent]);
           sl=addtxt(sl,"always @(*) begin\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"  case(");
           sl=addsl(sl,(yyvsp[-8].e)->sl);
           free((yyvsp[-8].e));
           sl=addtxt(sl,")\n");
           if((yyvsp[-6].sl))
             sl=addsl(sl,(yyvsp[-6].sl));
           s=sbottom((yyvsp[-4].ss)->sl);
           if((sg=lookup(io_list,s))==NULL)
             sg=lookup(sig_list,s);
           if(sg)
             sg->type=reg;
           findothers((yyvsp[-4].ss),(yyvsp[-1].sl));
           free((yyvsp[-4].ss));
           sl=addsl(sl,(yyvsp[-1].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"  endcase\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3242 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1344 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           sl=addsl((yyvsp[-14].sl),indents[indent]);
           sl=addtxt(sl,(yyvsp[-11].txt)); /* NAME2 */
           sl=addtxt(sl," ");
           sl=addtxt(sl,(yyvsp[-13].txt)); /* NAME1 */
           sl=addtxt(sl,"(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[-5].sl));  /* map_list */
           sl=addtxt(sl,");\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* a_body */
         }
#line 3259 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1357 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           sl=addsl((yyvsp[-20].sl),indents[indent]);
           sl=addtxt(sl,(yyvsp[-17].txt)); /* NAME2 (component name) */
           if ((yyvsp[-16].sl)) {
             sl=addsl(sl,(yyvsp[-16].sl));
             sl=addsl(sl,indents[indent]);
           }
           sl=addtxt(sl," #(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[-11].sl)); /* (generic) map_list */
           sl=addtxt(sl,")\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,(yyvsp[-19].txt)); /* NAME1 (instance name) */
           sl=addtxt(sl,"(\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[-4].sl)); /* map_list */
           sl=addtxt(sl,");\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* a_body */
         }
#line 3284 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 1377 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           if (0) fprintf(stderr,"process style 1\n");
           sl=add_always((yyvsp[-15].sl),(yyvsp[-12].sl),(yyvsp[-10].sl),0);
           sl=addsl(sl,(yyvsp[-6].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3298 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1387 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             if (0) fprintf(stderr,"process style 2: if then end if\n");
             sl=add_always((yyvsp[-22].sl),(yyvsp[-19].sl),(yyvsp[-17].sl),1);
             if((yyvsp[-13].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[-13].sl));
             }
             sl=addsl(sl,(yyvsp[-9].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3316 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1405 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             if (0) fprintf(stderr,"process style 3: if then elsif then end if\n");
             sl=add_always((yyvsp[-30].sl),(yyvsp[-27].sl),(yyvsp[-25].sl),1);
             if((yyvsp[-21].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[-21].sl));
             }
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  if(");
             sl=addsl(sl,(yyvsp[-19].sl));
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[-16].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end else begin\n");
             sl=addsl(sl,(yyvsp[-10].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end\n");
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3343 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1432 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             if (0) fprintf(stderr,"process style 4: if then else if then end if\n");
             sl=add_always((yyvsp[-34].sl),(yyvsp[-31].sl),(yyvsp[-29].sl),1);
             if((yyvsp[-25].sl)){
               sl=addsl(sl,indents[indent]);
               sl=addsl(sl,(yyvsp[-25].sl));
             }
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  if(");
             sl=addsl(sl,(yyvsp[-23].sl)); /* exprc */
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[-20].sl)); /* p_body:1 */
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end else begin\n");
             sl=addsl(sl,(yyvsp[-13].sl)); /* p_body:2 */
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"  end\n");
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl)); /* a_body */
         }
#line 3370 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1457 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
         blknamelist *tname_list;
           sl=addsl((yyvsp[-10].sl),indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"if (");
           sl=addsl(sl,(yyvsp[-8].sl)); /* exprc */
           sl=addtxt(sl,") begin: ");
           tname_list=blkname_list;
           sl=addtxt(sl,tname_list->name);
           blkname_list=blkname_list->next;
           if (tname_list!=NULL) {
           free(tname_list->name);
           free(tname_list);
           }
           sl=addtxt(sl,"\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[-5].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));    /* a_body:2 */
         }
#line 3399 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1482 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
         blknamelist *tname_list;
           sl=addsl((yyvsp[-14].sl),indents[indent]);
           sl=addtxt(sl,"genvar ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,";\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[-10].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[-8].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," + 1) begin: ");
           tname_list=blkname_list;
           sl=addtxt(sl,tname_list->name);
           blkname_list=blkname_list->next;
           if (tname_list!=NULL) {
           free(tname_list->name);
           free(tname_list);
           }
           sl=addtxt(sl,"\n");
           sl=addsl(sl,indents[indent]);
           sl=addsl(sl,(yyvsp[-5].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));    /* a_body:2 */
         }
#line 3442 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1521 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           blknamelist* tname_list;
           sl=addsl((yyvsp[-14].sl),indents[indent]);
           sl=addtxt(sl,"genvar ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,";\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"generate ");
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[-10].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," >= ");
           sl=addsl(sl,(yyvsp[-8].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," - 1) begin: ");
           tname_list=blkname_list;
           sl=addtxt(sl,tname_list->name);
           blkname_list=blkname_list->next;
           if (tname_list!=NULL) {
           free(tname_list->name);
           free(tname_list);
           }
           sl=addtxt(sl,"\n");
           sl=addsl(sl,(yyvsp[-5].sl));   /* a_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endgenerate\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));    /* a_body:2 */
         }
#line 3484 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1560 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=NULL;}
#line 3490 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1561 "vhd2vl.y" /* yacc.c:1646  */
    {free((yyvsp[0].txt)); (yyval.sl)=NULL;}
#line 3496 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1564 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=(yyvsp[0].sl);}
#line 3502 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1565 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=(yyvsp[-2].sl); free((yyvsp[-1].txt));}
#line 3508 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1567 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=(yyvsp[0].sl);}
#line 3514 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 1568 "vhd2vl.y" /* yacc.c:1646  */
    {
           blknamelist *tname_list;
           tname_list = xmalloc (sizeof(blknamelist));
           tname_list->name = xmalloc(strlen((yyvsp[-1].txt)));
           strcpy(tname_list->name, (yyvsp[-1].txt));
           tname_list->next = blkname_list;
           blkname_list=tname_list;
           (yyval.sl)=(yyvsp[-2].sl);
           free((yyvsp[-1].txt));
         }
#line 3529 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1580 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addwrap("(",(yyvsp[-1].sl),")");}
#line 3535 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1581 "vhd2vl.y" /* yacc.c:1646  */
    {
         push_clkedge((yyvsp[0].sl)->data.sl->data.txt[0]-'0', "name'event and exprc");
       }
#line 3543 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1584 "vhd2vl.y" /* yacc.c:1646  */
    {
         push_clkedge((yyvsp[-4].sl)->data.sl->data.txt[0]-'0', "exprc and name'event");
       }
#line 3551 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1587 "vhd2vl.y" /* yacc.c:1646  */
    {
         push_clkedge(1, "explicit");
       }
#line 3559 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1590 "vhd2vl.y" /* yacc.c:1646  */
    {
         push_clkedge(0, "explicit");
       }
#line 3567 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1595 "vhd2vl.y" /* yacc.c:1646  */
    {dowith=1;}
#line 3573 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1597 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=(yyvsp[-1].sl);}
#line 3579 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1598 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl;
              if((yyvsp[-1].sl)){
                sl=addsl((yyvsp[-3].sl),(yyvsp[-1].sl));
                (yyval.sl)=addsl(sl,(yyvsp[0].sl));
              } else
                (yyval.sl)=addsl((yyvsp[-3].sl),(yyvsp[0].sl));
            }
#line 3592 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1606 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl;
              sl=addtxt(indents[indent],"    default : ");
              sl=addsl(sl,slwith);
              sl=addtxt(sl," <= ");
              if(delay && (yyvsp[-3].n)){
                sl=addtxt(sl,"# ");
                sl=addval(sl,(yyvsp[-3].n));
                sl=addtxt(sl," ");
              }
              if((yyvsp[-4].e)->op == 'c')
                sl=addsl(sl,addwrap("{",(yyvsp[-4].e)->sl,"}"));
              else
                sl=addsl(sl,(yyvsp[-4].e)->sl);
              free((yyvsp[-4].e));
              delay=1;
              (yyval.sl)=addtxt(sl,";\n");
            }
#line 3615 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1625 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl;
              sl=addtxt(indents[indent],"    ");
              sl=addsl(sl,(yyvsp[0].sl));
              sl=addtxt(sl," : ");
              sl=addsl(sl,slwith);
              sl=addtxt(sl," <= ");
              if(delay && (yyvsp[-2].n)){
                sl=addtxt(sl,"# ");
                sl=addval(sl,(yyvsp[-2].n));
                sl=addtxt(sl," ");
              }
              if((yyvsp[-3].e)->op == 'c')
                sl=addsl(sl,addwrap("{",(yyvsp[-3].e)->sl,"}"));
              else
                sl=addsl(sl,(yyvsp[-3].e)->sl);
              free((yyvsp[-3].e));
              delay=1;
              (yyval.sl)=addtxt(sl,";\n");
            }
#line 3640 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1646 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=(yyvsp[0].sl);}
#line 3646 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1647 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
         sglist *sg, *p;
           sl=addtxt((yyvsp[-6].sl),"    reg");
           sl=addpar(sl,(yyvsp[-2].v));
           free((yyvsp[-2].v));
           sg=(yyvsp[-4].sg);
           for(;;){
             sl=addtxt(sl,sg->name);
             p=sg;
             sg=sg->next;
             free(p);
             if(sg)
               sl=addtxt(sl,", ");
             else
               break;
           }
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3671 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1667 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
         sglist *sg, *p;
           sl=addtxt((yyvsp[-9].sl),"    reg");
           sl=addpar(sl,(yyvsp[-5].v));
           free((yyvsp[-5].v));
           sg=(yyvsp[-7].sg);
           for(;;){
             sl=addtxt(sl,sg->name);
             p=sg;
             sg=sg->next;
             free(p);
             if(sg)
               sl=addtxt(sl,", ");
             else
               break;
           }
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-2].e)->sl);
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3698 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1691 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=(yyvsp[0].sl);}
#line 3704 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1693 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           sl=addsl((yyvsp[-8].sl),indents[indent]);
           sl=addsl(sl,(yyvsp[-7].ss)->sl);
           findothers((yyvsp[-7].ss),(yyvsp[-3].e)->sl);
           sl=addtxt(sl," = ");
           if((yyvsp[-3].e)->op == 'c')
             sl=addsl(sl,addwrap("{",(yyvsp[-3].e)->sl,"}"));
           else
             sl=addsl(sl,(yyvsp[-3].e)->sl);
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3722 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1707 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
         sglist *sg;
         char *s;

           s=sbottom((yyvsp[-6].ss)->sl);
           if((sg=lookup(io_list,s))==NULL)
             sg=lookup(sig_list,s);
           if(sg)
             sg->type=reg;
           sl=addsl((yyvsp[-7].sl),indents[indent]);
           sl=addsl(sl,(yyvsp[-6].ss)->sl);
           findothers((yyvsp[-6].ss),(yyvsp[-2].sl));
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[-2].sl));
           sl=addtxt(sl,";\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3745 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1726 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           sl=addsl((yyvsp[-11].sl),indents[indent]);
           sl=addtxt(sl,"if(");
           sl=addsl(sl,(yyvsp[-9].sl));
           sl=addtxt(sl,") begin\n");
           sl=addsl(sl,(yyvsp[-6].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           sl=addsl(sl,(yyvsp[-4].sl));
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3762 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1739 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           sl=addsl((yyvsp[-14].sl),indents[indent]);
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[-10].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," <= ");
           sl=addsl(sl,(yyvsp[-8].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," + 1) begin\n");
           sl=addsl(sl,(yyvsp[-5].sl));    /* p_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));    /* p_body:2 */
         }
#line 3788 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1761 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           sl=addsl((yyvsp[-14].sl),indents[indent]);
           sl=addtxt(sl,"for (");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl,"=");
           sl=addsl(sl,(yyvsp[-10].e)->sl); /* expr:1 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," >= ");
           sl=addsl(sl,(yyvsp[-8].e)->sl); /* expr:2 */
           sl=addtxt(sl,"; ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," = ");
           sl=addsl(sl,(yyvsp[-12].ss)->sl); /* signal */
           sl=addtxt(sl," - 1) begin\n");
           sl=addsl(sl,(yyvsp[-5].sl));    /* p_body:1 */
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"end\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));    /* p_body:2 */
         }
#line 3814 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1783 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           sl=addsl((yyvsp[-9].sl),indents[indent]);
           sl=addtxt(sl,"case(");
           sl=addsl(sl,(yyvsp[-7].ss)->sl); /* signal */
           sl=addtxt(sl,")\n");
           if((yyvsp[-5].sl)){
             sl=addsl(sl,indents[indent]);
             sl=addsl(sl,(yyvsp[-5].sl));
           }
           sl=addsl(sl,(yyvsp[-4].sl));
           sl=addsl(sl,indents[indent]);
           sl=addtxt(sl,"endcase\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3834 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1798 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           sl=addsl((yyvsp[-3].sl),indents[indent]);
           sl=addtxt(sl,"disable;  //VHD2VL: add block name here\n");
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));
         }
#line 3845 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1804 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
           if((yyvsp[-3].sl)){
             sl=addsl((yyvsp[-3].sl),indents[indent]);
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
           }else
             (yyval.sl)=(yyvsp[0].sl);
         }
#line 3858 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1814 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=NULL;}
#line 3864 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1815 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             sl=addtxt(indents[indent],"else if(");
             sl=addsl(sl,(yyvsp[-5].sl));
             sl=addtxt(sl,") begin\n");
             sl=addsl(sl,(yyvsp[-2].sl));
             sl=addsl(sl,indents[indent]);
             sl=addtxt(sl,"end\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
           }
#line 3879 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1825 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             sl=addtxt(indents[indent],"else begin\n");
             sl=addsl(sl,(yyvsp[-1].sl));
             sl=addsl(sl,indents[indent]);
             (yyval.sl)=addtxt(sl,"end\n");
           }
#line 3891 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1834 "vhd2vl.y" /* yacc.c:1646  */
    {
        slist *sl;
          sl=addsl(indents[indent],(yyvsp[-6].sl));
          sl=addtxt(sl," : begin\n");
          sl=addsl(sl,(yyvsp[-2].sl));
          sl=addsl(sl,indents[indent]);
          sl=addtxt(sl,"end\n");
          (yyval.sl)=addsl(sl,(yyvsp[0].sl));
        }
#line 3905 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1843 "vhd2vl.y" /* yacc.c:1646  */
    {
        slist *sl;
          sl=addtxt(indents[indent],"default : begin\n");
          sl=addsl(sl,(yyvsp[-1].sl));
          sl=addsl(sl,indents[indent]);
          (yyval.sl)=addtxt(sl,"end\n");
        }
#line 3917 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1850 "vhd2vl.y" /* yacc.c:1646  */
    { (yyval.sl)=NULL; }
#line 3923 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1853 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=(yyvsp[0].sl);}
#line 3929 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1854 "vhd2vl.y" /* yacc.c:1646  */
    {
        slist *sl;
          sl=addtxt((yyvsp[-2].sl),",");
          (yyval.sl)=addsl(sl,(yyvsp[0].sl));
        }
#line 3939 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1861 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addvec(NULL,(yyvsp[0].txt));}
#line 3945 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1862 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addvec_base(NULL,(yyvsp[-1].txt),(yyvsp[0].txt));}
#line 3951 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1863 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addtxt(NULL,(yyvsp[0].txt));}
#line 3957 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1866 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=(yyvsp[0].ss)->sl; free((yyvsp[0].ss));}
#line 3963 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1867 "vhd2vl.y" /* yacc.c:1646  */
    {
            slist *sl;
              sl=addtxt((yyvsp[-2].ss)->sl," or ");
              free((yyvsp[-2].ss));
              (yyval.sl)=addsl(sl,(yyvsp[0].sl));
            }
#line 3974 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1875 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             if(delay && (yyvsp[-1].n)){
               sl=addtxt(NULL,"# ");
               sl=addval(sl,(yyvsp[-1].n));
               sl=addtxt(sl," ");
             } else
               sl=NULL;
             if((yyvsp[-2].e)->op == 'c')
               sl=addsl(sl,addwrap("{",(yyvsp[-2].e)->sl,"}"));
             else
               sl=addsl(sl,(yyvsp[-2].e)->sl);
             free((yyvsp[-2].e));
             delay=1;
             (yyval.sl)=sl;
           }
#line 3995 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1891 "vhd2vl.y" /* yacc.c:1646  */
    {
             fprintf(stderr,"Warning on line %d: Can't translate 'expr delay WHEN exprc;' expressions\n",lineno);
             (yyval.sl)=NULL;
           }
#line 4004 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1895 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             sl=addtxt((yyvsp[-3].sl)," ? ");
             if((yyvsp[-6].e)->op == 'c')
               sl=addsl(sl,addwrap("{",(yyvsp[-6].e)->sl,"}"));
             else
               sl=addsl(sl,(yyvsp[-6].e)->sl);
             free((yyvsp[-6].e));
             sl=addtxt(sl," : ");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
           }
#line 4020 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1908 "vhd2vl.y" /* yacc.c:1646  */
    {delay=0;}
#line 4026 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1911 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.n)=0;}
#line 4032 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1912 "vhd2vl.y" /* yacc.c:1646  */
    {
             set_timescale((yyvsp[0].txt));
             (yyval.n)=(yyvsp[-1].n);
           }
#line 4041 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1918 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
           sl=addsl((yyvsp[-1].sl),indents[indent]);
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));}
#line 4050 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1922 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             sl=addsl((yyvsp[-3].sl),indents[indent]);
             sl=addsl(sl,(yyvsp[-2].sl));
             sl=addtxt(sl,",\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
           }
#line 4062 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1931 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=(yyvsp[0].sl);}
#line 4068 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1932 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             sl=addtxt(NULL,".");
             sl=addtxt(sl,(yyvsp[-3].txt));
             sl=addtxt(sl,"(");
             sl=addsl(sl,(yyvsp[0].sl));
             (yyval.sl)=addtxt(sl,")");
           }
#line 4081 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1942 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addvec(NULL,(yyvsp[0].txt));}
#line 4087 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1943 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addsl(NULL,(yyvsp[0].ss)->sl);}
#line 4093 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1944 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addval(NULL,(yyvsp[0].n));}
#line 4099 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1945 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addvec_base(NULL,(yyvsp[-1].txt),(yyvsp[0].txt));}
#line 4105 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1946 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.sl)=addtxt(NULL,"/* open */");}
#line 4111 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1947 "vhd2vl.y" /* yacc.c:1646  */
    {
             (yyval.sl)=addtxt(NULL,"{broken{");
             (yyval.sl)=addtxt((yyval.sl),(yyvsp[-1].txt));
             (yyval.sl)=addtxt((yyval.sl),"}}");
             fprintf(stderr,"Warning on line %d: broken width on port with OTHERS\n",lineno);
           }
#line 4122 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1956 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
           sl=addsl((yyvsp[-1].sl),indents[indent]);
           (yyval.sl)=addsl(sl,(yyvsp[0].sl));}
#line 4131 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1960 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             sl=addsl((yyvsp[-3].sl),indents[indent]);
             sl=addsl(sl,(yyvsp[-2].sl));
             sl=addtxt(sl,",\n");
             (yyval.sl)=addsl(sl,(yyvsp[0].sl));
           }
#line 4143 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1967 "vhd2vl.y" /* yacc.c:1646  */
    {  /* only allow a single un-named map item */
             (yyval.sl)=addsl(NULL,(yyvsp[0].e)->sl);
           }
#line 4151 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1972 "vhd2vl.y" /* yacc.c:1646  */
    {
           slist *sl;
             sl=addtxt(NULL,".");
             sl=addtxt(sl,(yyvsp[-3].txt));
             sl=addtxt(sl,"(");
             sl=addsl(sl,(yyvsp[0].e)->sl);
             (yyval.sl)=addtxt(sl,")");
           }
#line 4164 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1982 "vhd2vl.y" /* yacc.c:1646  */
    {
         slist *sl;
         slval *ss;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[0].txt));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->val=-1;
           ss->range=NULL;
           (yyval.ss)=ss;
         }
#line 4183 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1996 "vhd2vl.y" /* yacc.c:1646  */
    {
         slval *ss;
         slist *sl;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[-3].txt));
           sl=addpar_snug(sl,(yyvsp[-1].v));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->range=(yyvsp[-1].v);
           if((yyvsp[-1].v)->vtype==tVRANGE) {
             if (0) {
               fprintf(stderr,"ss->val set to 1 for ");
               fslprint(stderr,ss->sl);
               fprintf(stderr,", why?\n");
             }
             ss->val = -1; /* width is in the vrange */
           } else {
             ss->val = 1;
           }
           (yyval.ss)=ss;
         }
#line 4212 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 2020 "vhd2vl.y" /* yacc.c:1646  */
    {
         slval *ss;
         slist *sl;
           ss=xmalloc(sizeof(slval));
           sl=addtxt(NULL,(yyvsp[-6].txt));
           sl=addpar_snug2(sl,(yyvsp[-4].v), (yyvsp[-1].v));
           if(dowith){
             slwith=sl;
             dowith=0;
           }
           ss->sl=sl;
           ss->range=(yyvsp[-4].v);
           if((yyvsp[-4].v)->vtype==tVRANGE) {
             ss->val = -1; /* width is in the vrange */
           } else {
             ss->val = 1;
           }
           (yyval.ss)=ss;
         }
#line 4236 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 2042 "vhd2vl.y" /* yacc.c:1646  */
    {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=(yyvsp[0].ss)->sl;
           free((yyvsp[0].ss));
           (yyval.e)=e;
         }
#line 4249 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 2050 "vhd2vl.y" /* yacc.c:1646  */
    {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addvec(NULL,(yyvsp[0].txt));
           (yyval.e)=e;
         }
#line 4261 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 2057 "vhd2vl.y" /* yacc.c:1646  */
    {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addtxt(NULL,(yyvsp[0].txt));
           (yyval.e)=e;
         }
#line 4272 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 2063 "vhd2vl.y" /* yacc.c:1646  */
    {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addval(NULL,(yyvsp[0].n));
           (yyval.e)=e;
         }
#line 4283 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 2069 "vhd2vl.y" /* yacc.c:1646  */
    {  /* e.g. 16#55aa# */
         /* XXX unify this code with addvec_base */
         expdata *e=xmalloc(sizeof(expdata));
         char *natval = xmalloc(strlen((yyvsp[0].txt))+34);
           e->op='t'; /* Terminal symbol */
           switch((yyvsp[-1].n)) {
           case  2:
             sprintf(natval, "'B%s",(yyvsp[0].txt));
             break;
           case  8:
             sprintf(natval, "'O%s",(yyvsp[0].txt));
             break;
           case 10:
             sprintf(natval, "'D%s",(yyvsp[0].txt));
             break;
           case 16:
             sprintf(natval, "'H%s",(yyvsp[0].txt));
             break;
           default:
             sprintf(natval,"%d#%s#",(yyvsp[-1].n),(yyvsp[0].txt));
             fprintf(stderr,"Warning on line %d: Can't translate based number %s (only bases of 2, 8, 10, and 16 are translatable)\n",lineno,natval);
           }
           e->sl=addtxt(NULL,natval);
           (yyval.e)=e;
         }
#line 4313 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 2094 "vhd2vl.y" /* yacc.c:1646  */
    {
         expdata *e=xmalloc(sizeof(expdata));
           e->op='t'; /* Terminal symbol */
           e->sl=addvec_base(NULL,(yyvsp[-1].txt),(yyvsp[0].txt));
           (yyval.e)=e;
         }
#line 4324 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 2100 "vhd2vl.y" /* yacc.c:1646  */
    {
         expdata *e;
           e=xmalloc(sizeof(expdata));
           e->op='o'; /* others */
           e->sl=addothers(NULL,(yyvsp[-1].txt));
           (yyval.e)=e;
         }
#line 4336 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 2107 "vhd2vl.y" /* yacc.c:1646  */
    { /* Vector chaining */
         slist *sl;
           sl=addtxt((yyvsp[-2].e)->sl,",");
           sl=addsl(sl,(yyvsp[0].e)->sl);
           free((yyvsp[0].e));
           (yyvsp[-2].e)->op='c';
           (yyvsp[-2].e)->sl=sl;
           (yyval.e)=(yyvsp[-2].e);
         }
#line 4350 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 2116 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr(NULL,'m'," -",(yyvsp[0].e));}
#line 4356 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 2117 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr(NULL,'p'," +",(yyvsp[0].e));}
#line 4362 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 2118 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr((yyvsp[-2].e),'+'," + ",(yyvsp[0].e));}
#line 4368 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 2119 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr((yyvsp[-2].e),'-'," - ",(yyvsp[0].e));}
#line 4374 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 2120 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr((yyvsp[-2].e),'*'," * ",(yyvsp[0].e));}
#line 4380 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 2121 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr((yyvsp[-2].e),'/'," / ",(yyvsp[0].e));}
#line 4386 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 2122 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr((yyvsp[-2].e),'%'," % ",(yyvsp[0].e));}
#line 4392 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 2123 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr(NULL,'~'," ~",(yyvsp[0].e));}
#line 4398 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 2124 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr((yyvsp[-2].e),'&'," & ",(yyvsp[0].e));}
#line 4404 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 2125 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr((yyvsp[-2].e),'|'," | ",(yyvsp[0].e));}
#line 4410 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 2126 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr((yyvsp[-2].e),'^'," ^ ",(yyvsp[0].e));}
#line 4416 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 2127 "vhd2vl.y" /* yacc.c:1646  */
    {(yyval.e)=addexpr(NULL,'~'," ~",addexpr((yyvsp[-2].e),'^'," ^ ",(yyvsp[0].e)));}
#line 4422 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 2128 "vhd2vl.y" /* yacc.c:1646  */
    {
       /* single argument type conversion function e.g. std_ulogic_vector(x) */
       expdata *e;
       e=xmalloc(sizeof(expdata));
       if ((yyvsp[-1].e)->op == 'c') {
         e->sl=addwrap("{",(yyvsp[-1].e)->sl,"}");
       } else {
         e->sl=addwrap("(",(yyvsp[-1].e)->sl,")");
       }
       (yyval.e)=e;
      }
#line 4438 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 2139 "vhd2vl.y" /* yacc.c:1646  */
    {
       /* two argument type conversion e.g. to_unsigned(x, 3) */
       (yyval.e) = addnest((yyvsp[-3].e));
      }
#line 4447 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 2143 "vhd2vl.y" /* yacc.c:1646  */
    {
       (yyval.e) = addnest((yyvsp[-3].e));
      }
#line 4455 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 2146 "vhd2vl.y" /* yacc.c:1646  */
    {
       (yyval.e) = addnest((yyvsp[-1].e));
      }
#line 4463 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 2152 "vhd2vl.y" /* yacc.c:1646  */
    { (yyval.sl)=(yyvsp[0].sl); }
#line 4469 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 2153 "vhd2vl.y" /* yacc.c:1646  */
    {
         (yyval.sl)=addwrap("(",(yyvsp[-1].sl),")");
      }
#line 4477 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 2156 "vhd2vl.y" /* yacc.c:1646  */
    {
        slist *sl;
          sl=addtxt((yyvsp[-2].sl)," && ");
          (yyval.sl)=addsl(sl,(yyvsp[0].sl));
        }
#line 4487 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 2161 "vhd2vl.y" /* yacc.c:1646  */
    {
        slist *sl;
          sl=addtxt((yyvsp[-2].sl)," || ");
          (yyval.sl)=addsl(sl,(yyvsp[0].sl));
        }
#line 4497 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 2166 "vhd2vl.y" /* yacc.c:1646  */
    {
        slist *sl;
          sl=addtxt(NULL,"!");
          (yyval.sl)=addsl(sl,(yyvsp[0].sl));
        }
#line 4507 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 2174 "vhd2vl.y" /* yacc.c:1646  */
    {
       slist *sl;
         if((yyvsp[-2].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-2].e)->sl,"} == ");
         else if((yyvsp[-2].e)->op != 't')
           sl=addwrap("(",(yyvsp[-2].e)->sl,") == ");
         else
           sl=addtxt((yyvsp[-2].e)->sl," == ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-2].e));
         free((yyvsp[0].e));
       }
#line 4529 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 2191 "vhd2vl.y" /* yacc.c:1646  */
    {
       slist *sl;
         if((yyvsp[-2].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-2].e)->sl,"} > ");
         else if((yyvsp[-2].e)->op != 't')
           sl=addwrap("(",(yyvsp[-2].e)->sl,") > ");
         else
           sl=addtxt((yyvsp[-2].e)->sl," > ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-2].e));
         free((yyvsp[0].e));
       }
#line 4551 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 2208 "vhd2vl.y" /* yacc.c:1646  */
    {
       slist *sl;
         if((yyvsp[-3].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-3].e)->sl,"} >= ");
         else if((yyvsp[-3].e)->op != 't')
           sl=addwrap("(",(yyvsp[-3].e)->sl,") >= ");
         else
           sl=addtxt((yyvsp[-3].e)->sl," >= ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-3].e));
         free((yyvsp[0].e));
       }
#line 4573 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 2225 "vhd2vl.y" /* yacc.c:1646  */
    {
       slist *sl;
         if((yyvsp[-2].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-2].e)->sl,"} < ");
         else if((yyvsp[-2].e)->op != 't')
           sl=addwrap("(",(yyvsp[-2].e)->sl,") < ");
         else
           sl=addtxt((yyvsp[-2].e)->sl," < ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-2].e));
         free((yyvsp[0].e));
       }
#line 4595 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 2242 "vhd2vl.y" /* yacc.c:1646  */
    {
       slist *sl;
         if((yyvsp[-3].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-3].e)->sl,"} <= ");
         else if((yyvsp[-3].e)->op != 't')
           sl=addwrap("(",(yyvsp[-3].e)->sl,") <= ");
         else
           sl=addtxt((yyvsp[-3].e)->sl," <= ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-3].e));
         free((yyvsp[0].e));
       }
#line 4617 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 2259 "vhd2vl.y" /* yacc.c:1646  */
    {
       slist *sl;
         if((yyvsp[-3].e)->op == 'c')
           sl=addwrap("{",(yyvsp[-3].e)->sl,"} != ");
         else if((yyvsp[-3].e)->op != 't')
           sl=addwrap("(",(yyvsp[-3].e)->sl,") != ");
         else
           sl=addtxt((yyvsp[-3].e)->sl," != ");
         if((yyvsp[0].e)->op == 'c')
           (yyval.sl)=addsl(sl,addwrap("{",(yyvsp[0].e)->sl,"}"));
         else if((yyvsp[0].e)->op != 't')
           (yyval.sl)=addsl(sl,addwrap("(",(yyvsp[0].e)->sl,")"));
         else
           (yyval.sl)=addsl(sl,(yyvsp[0].e)->sl);
         free((yyvsp[-3].e));
         free((yyvsp[0].e));
       }
#line 4639 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 2278 "vhd2vl.y" /* yacc.c:1646  */
    {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='t'; /* Terminal symbol */
         e->sl=(yyvsp[0].ss)->sl;
         free((yyvsp[0].ss));
         (yyval.e)=e;
      }
#line 4652 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 2286 "vhd2vl.y" /* yacc.c:1646  */
    {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='t'; /* Terminal symbol */
         e->sl=addvec(NULL,(yyvsp[0].txt));
         (yyval.e)=e;
      }
#line 4664 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 2293 "vhd2vl.y" /* yacc.c:1646  */
    {
         expdata *e;
         e=xmalloc(sizeof(expdata));
         e->op='n'; /* natural */
         e->value=(yyvsp[0].n);
         e->sl=addval(NULL,(yyvsp[0].n));
         (yyval.e)=e;
      }
#line 4677 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 2301 "vhd2vl.y" /* yacc.c:1646  */
    {
	      /* lookup NAME and get its left */
              sglist *sg = NULL;
              if((sg=lookup(io_list,(yyvsp[-2].txt)))==NULL) {
                sg=lookup(sig_list,(yyvsp[-2].txt));
              }
              if(sg) {
                expdata *e;
                e=xmalloc(sizeof(expdata));
                e->sl=addwrap("(",sg->range->nhi,")");  /* XXX left vs. high? */
                (yyval.e)=e;
              } else {
                fprintf(stderr,"Undefined left \"%s'left\" on line %d\n",(yyvsp[-2].txt),lineno);
                YYABORT;
              }
      }
#line 4698 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 2317 "vhd2vl.y" /* yacc.c:1646  */
    {
       (yyval.e)=addexpr((yyvsp[-2].e),'+'," + ",(yyvsp[0].e));
      }
#line 4706 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 2320 "vhd2vl.y" /* yacc.c:1646  */
    {
       (yyval.e)=addexpr((yyvsp[-2].e),'-'," - ",(yyvsp[0].e));
      }
#line 4714 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 2323 "vhd2vl.y" /* yacc.c:1646  */
    {
       (yyval.e)=addexpr((yyvsp[-2].e),'*'," * ",(yyvsp[0].e));
      }
#line 4722 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 2326 "vhd2vl.y" /* yacc.c:1646  */
    {
       (yyval.e)=addexpr((yyvsp[-2].e),'/'," / ",(yyvsp[0].e));
      }
#line 4730 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 2329 "vhd2vl.y" /* yacc.c:1646  */
    {
       /* one argument type conversion e.g. conv_integer(x) */
       expdata *e;
       e=xmalloc(sizeof(expdata));
       e->sl=addwrap("(",(yyvsp[-1].e)->sl,")");
       (yyval.e)=e;
      }
#line 4742 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 2336 "vhd2vl.y" /* yacc.c:1646  */
    {
       expdata *e;
       e=xmalloc(sizeof(expdata));
       e->sl=addwrap("(",(yyvsp[-1].e)->sl,")");
       (yyval.e)=e;
      }
#line 4753 "vhd2vl.tab.c" /* yacc.c:1646  */
    break;


#line 4757 "vhd2vl.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2344 "vhd2vl.y" /* yacc.c:1906  */


const char *outfile;    /* Output file */
const char *sourcefile; /* Input file */

int main(int argc, char *argv[]){
int i,j;
char *s;
slist *sl;
int status;

  /* Init the indentation variables */
  indents[0]=NULL;
  for(i=1;i<MAXINDENT;i++){
    indents[i]=sl=xmalloc(sizeof(slist));
    sl->data.txt=s=xmalloc(sizeof(char) *((i<<1)+1));
    for(j=0;j<(i<<1);j++)
      *s++=' ';
    *s=0;
    sl->type=1;
    sl->slst=NULL;
  }
  if (argc >= 2 && strcmp(argv[1], "--help") == 0) {
    printf(
      "Usage: vhd2vl [-d] [-g1995|-g2001] source_file.vhd > target_file.v\n"
      "   or  vhd2vl [-d] [-g1995|-g2001] source_file.vhd target_file.v\n");
    exit(EXIT_SUCCESS);
  }

  while (argc >= 2) {
     if (strcmp(argv[1], "-d") == 0) {
       yydebug = 1;
     } else if (strcmp(argv[1], "-g1995") == 0) {
       vlog_ver = 0;
     } else if (strcmp(argv[1], "-g2001") == 0) {
       vlog_ver = 1;
     } else {
       break;
     }
     argv++;
     argc--;
  }
  if (argc>=2) {
     sourcefile = argv[1];
     if (strcmp(sourcefile,"-")!=0 && !freopen(sourcefile, "r", stdin)) {
        fprintf(stderr, "Error: Can't open input file '%s'\n", sourcefile);
        return(1);
     }
  } else {
     sourcefile = "-";
  }

  if (argc>=3) {
     outfile = argv[2];
     if (strcmp(outfile,"-")!=0 && !freopen(outfile, "w", stdout)) {
        fprintf(stderr, "Error: Can't open output file '%s'\n", outfile);
        return(1);
     }
  } else {
     outfile = "-";
  }

  printf("// File %s translated with vhd2vl v2.5 VHDL to Verilog RTL translator\n", sourcefile);
  printf("// vhd2vl settings:\n"
         "//  * Verilog Module Declaration Style: %s\n\n",
         vlog_ver ? "2001" : "1995");
  fputs(
"// vhd2vl is Free (libre) Software:\n"
"//   Copyright (C) 2001 Vincenzo Liguori - Ocean Logic Pty Ltd\n"
"//     http://www.ocean-logic.com\n"
"//   Modifications Copyright (C) 2006 Mark Gonzales - PMC Sierra Inc\n"
"//   Modifications (C) 2010 Shankar Giri\n"
"//   Modifications Copyright (C) 2002, 2005, 2008-2010, 2015 Larry Doolittle - LBNL\n"
"//     http://doolittle.icarus.com/~larry/vhd2vl/\n"
"//\n", stdout);
  fputs(
"//   vhd2vl comes with ABSOLUTELY NO WARRANTY.  Always check the resulting\n"
"//   Verilog for correctness, ideally with a formal verification tool.\n"
"//\n"
"//   You are welcome to redistribute vhd2vl under certain conditions.\n"
"//   See the license (GPLv2) file included with the source for details.\n\n"
"// The result of translation follows.  Its copyright status should be\n"
"// considered unchanged from the original VHDL.\n\n"
  , stdout);
  status = yyparse();
  fclose(stdout);
  fclose(stdin);
  if (status != 0 && strcmp(outfile,"-")!=0) unlink(outfile);
  return status;
}
